define("io.ox/office/spreadsheet/app/drawingcontroller",["io.ox/office/tk/utils","io.ox/office/editframework/utils/color","io.ox/office/drawinglayer/utils/drawingutils","io.ox/office/drawinglayer/view/drawinglabels","io.ox/office/spreadsheet/utils/operations","io.ox/office/spreadsheet/model/formula/tokenarray","io.ox/office/spreadsheet/view/chartcreator","gettext!io.ox/office/spreadsheet/main"],function(a,b,c,d,e,f,g,h){"use strict";function i(i,j,k){function l(b){switch(b){case"sheets":k.yell({type:"warning",message:h("Data references are located on different sheets.")});break;case"directions":k.yell({type:"warning",message:h("Data references are too complex for this operation.")});break;default:a.warn('DrawingController.yellChartDirection(): unknown warning type: "'+b+'"')}return $.Deferred().reject()}function m(a,b){if(G&&(k.endRangeHighlighting(G),G=null),F=[],1===b.drawings.length){var c=k.getDrawingCollection().findModel(b.drawings[0],{type:"chart"});c&&c.getTokenArrays(F)}F.length>0&&(G=k.startRangeHighlighting(F,{priority:!0,resolveNames:!0}))}function n(){var a=k.getSelectedDrawings();return 1===a.length?a[0]:null}function o(a){var b=n();return b?k.getDrawingCollection().findModel(b,{type:a}):void 0}function p(a,b,c,d){return k.getSheetModel().createAndApplyOperations(function(e){var f=n(),g=d?$.when(d(e,f)):$.when();return g.done(function(){q(e,a,b,f,c)})},{storeSelection:!0})}function q(b,c,d,f,g){var h=null;switch(d){case e.SET_CHART_LEGEND_ATTRIBUTES:var i=c.getLegendModel(g.axis);h={attrs:i.getUndoAttributeSet(g.attrs)};break;case e.SET_CHART_TITLE_ATTRIBUTES:var j=c.getTitleModel(g.axis);h={axis:g.axis,attrs:j.getUndoAttributeSet(g.attrs)};break;case e.SET_CHART_AXIS_ATTRIBUTES:var k=c.getAxisModel(g.axis);h={axis:g.axis,attrs:k.getUndoAttributeSet(g.attrs)};break;case e.SET_CHART_GRIDLINE_ATTRIBUTES:var l=c.getAxisModel(g.axis).getGrid();h={axis:g.axis,attrs:l.getUndoAttributeSet(g.attrs)};break;case e.SET_DRAWING_ATTRIBUTES:h={attrs:c.getUndoAttributeSet(g.attrs)};break;default:return void a.error('generateChartOperation(): unknown operation "'+d+'"')}b.generateDrawingOperation(d,f,h,{undo:!0}),b.generateDrawingOperation(d,f,g)}function r(a){return _.isObject(a)?a.text.link[0]||"":""}function s(a,b,c){return p(a,e.SET_CHART_TITLE_ATTRIBUTES,{axis:b,attrs:c})}function t(a,b,c){return s(a,b,{text:{link:[c]},character:g.getHeadChar()})}function u(){var a=k.enterCustomSelectionMode("chartsource",{statusLabel:h("Select source data")});a.done(function(a){var b=a.ranges[0],c=k.getActiveSheet();E||(E=new f(k.getSheetModel(),"chart")),E.clearTokens().appendRange(b,{sheet:c,abs:!0});var d=o("chart"),e=d.getDataSourceInfo();return e.warn?g.updateSeries(i,b,c,d):g.updateSeries(i,b,c,d,e.axis)})}function v(a){var b=o("chart"),c=d.CHART_TYPE_STYLES[a],f=b.getMergedAttributeSet(!0).chart,h=0===f.type.indexOf("pie")||0===f.type.indexOf("donut"),j=0===c.type.indexOf("pie")||0===c.type.indexOf("donut"),k=0===f.type.indexOf("bubble"),m=0===c.type.indexOf("bubble");if(h!==j||k!==m){var n=b.getDataSourceInfo();return n.warn?l(n.warn):g.updateSeries(i,n.range,n.sheet,b,n.axis,c)}return p(b,e.SET_DRAWING_ATTRIBUTES,{attrs:{chart:c}},function(a,d){if("pie2d"===c.type||"donut2d"===c.type){var f={line:g.getNoneShape(),axis:{label:!1}};q(a,b,e.SET_CHART_AXIS_ATTRIBUTES,d,{attrs:f,axis:"x"}),q(a,b,e.SET_CHART_AXIS_ATTRIBUTES,d,{attrs:f,axis:"y"}),q(a,b,e.SET_CHART_GRIDLINE_ATTRIBUTES,d,{attrs:f,axis:"x"}),q(a,b,e.SET_CHART_GRIDLINE_ATTRIBUTES,d,{attrs:f,axis:"y"}),q(a,b,e.SET_CHART_TITLE_ATTRIBUTES,d,{attrs:{text:{link:[]},character:null},axis:"x"}),q(a,b,e.SET_CHART_TITLE_ATTRIBUTES,d,{attrs:{text:{link:[]},character:null},axis:"y"})}})}function w(a,b){if(!a)return null;var c=a.getDataSourceInfo();return c.warn?null:(c.axis&&(b=Math.abs(b-1)),1===b?a.isTitleLabel()||a.getFirstPointsCount()>1:a.isNamesLabel()||a.getSeriesCount()>1)}function x(a,b){if(!a)return null;var c=a.getDataSourceInfo();return c.warn?null:(c.axis&&(b=Math.abs(b-1)),1===b?a.isTitleLabel():a.isNamesLabel())}function y(a,b,c){if(!a)return null;var d=a.getDataSourceInfo();return d.warn?null:(d.axis&&(b=Math.abs(b-1)),1===b?g.updateSeries(i,d.range,d.sheet,a,d.axis,void 0,c,a.isNamesLabel()):g.updateSeries(i,d.range,d.sheet,a,d.axis,void 0,a.isTitleLabel(),c))}function z(a){var b=a.getDataSourceInfo();return b.warn?l(b.warn):g.updateSeries(i,b.range,b.sheet,a,1-b.axis,void 0,a.isNamesLabel(),a.isTitleLabel())}function A(a,b){function c(b){return b?b.getAxisIdForDrawing(a):a}function d(a){return{line:a?g.getStandardShape():g.getNoneShape()}}function f(a,b){return p(a,e.SET_CHART_AXIS_ATTRIBUTES,{axis:c(a),attrs:b})}function h(a,b){return p(a,e.SET_CHART_GRIDLINE_ATTRIBUTES,{axis:c(a),attrs:b})}var i="drawing/chart/axis/"+a+"/";b[i+"model"]={parent:["drawing/chart","drawing/chart/axes/enabled"],get:function(a){return a?a.getAxisModel(c(a)):null}},b[i+"attributes"]={parent:[i+"model","drawing/chart"],get:function(a){return a?a.getMergedAttributeSet(!0):null},set:function(a){return f(this.getParentValue(1),a)}},b[i+"labels/visible"]={parent:[i+"attributes","drawing/chart"],get:function(a){return _.isObject(a)&&a.axis.label===!0&&this.areParentsEnabled()},set:function(a){return f(this.getParentValue(1),{axis:{label:a}})}},b[i+"line/visible"]={parent:[i+"attributes","drawing/chart"],get:function(a){return _.isObject(a)&&"none"!==a.line.type},set:function(a){return f(this.getParentValue(1),d(a))}},b[i+"grid/model"]={parent:i+"model",get:function(a){return a?a.getGrid():null}},b[i+"grid/attributes"]={parent:[i+"grid/model","drawing/chart"],get:function(a){return a?a.getMergedAttributeSet(!0):null},set:function(a){return h(this.getParentValue(1),a)}},b[i+"grid/visible"]={parent:[i+"grid/attributes","drawing/chart"],get:function(a){return _.isObject(a)&&"none"!==a.line.type},set:function(a){return h(this.getParentValue(1),d(a))}},b[i+"title/model"]={parent:i+"model",get:function(a){return a?a.getTitle():null}},b[i+"title/attributes"]={parent:[i+"title/model","drawing/chart"],get:function(a){return a?a.getMergedAttributeSet(!0):null},set:function(a){var b=this.getParentValue(1);return s(b,c(b),a)}},b[i+"title/text"]={parent:[i+"title/attributes","drawing/chart"],get:function(a){return r(a)},set:function(a){var b=this.getParentValue(1);return t(b,c(b),a)}},b[i+"title/delete"]={parent:[i+"title/text","drawing/chart"],enable:function(){return this.getValue().length>0},set:function(){var a=this.getParentValue(1);return t(a,c(a),"")}}}function B(){var a={};a["image/insert"]={parent:"sheet/operation/unlocked",set:function(a){return k.insertImages(a)}},a["image/insert/dialog"]={parent:"sheet/operation/unlocked",set:function(a){return k.showInsertImageDialog(a)}},a["chart/insert"]={parent:"sheet/operation/unlocked",enable:function(){var a=k.getSelectedRanges();return 1===a.length&&!k.getSheetModel().isSingleCellInRange(a[0])},set:function(a){return g.createChart(i,d.CHART_TYPE_STYLES[a])}},a["drawing/operation"]={parent:"sheet/operation/unlocked",enable:function(){return k.hasDrawingSelection()}},a["drawing/model"]={parent:"drawing/operation",get:o},a["drawing/type/label"]={parent:"drawing/model",get:function(a){return d.getDrawingTypeLabel(a?a.getType():"")}},a["drawing/delete"]={parent:"drawing/operation",set:function(){return k.deleteDrawings()}},a["drawing/image"]={parent:"drawing/operation",enable:function(){return _.isObject(this.getValue())},get:function(){return o("image")}},a["drawing/chart"]={parent:"drawing/operation",enable:function(){return _.isObject(this.getValue())},get:function(){return o("chart")}},a["drawing/chartlabels"]={parent:"drawing/chart",get:function(){return k.getChartLabelsMenu().isVisible()},set:function(a){k.getChartLabelsMenu().toggle(a)}},a["drawing/chartexchange"]={parent:"drawing/chart",enable:function(a){return a.getSeriesCount()>0},set:function(){var a=o("chart");return z(a)}},a["drawing/chartfirstcol"]={parent:"drawing/chart",enable:function(a){return w(a,0)},get:function(a){return x(a,0)},set:function(a){return y(o("chart"),0,a)}},a["drawing/chartfirstrow"]={parent:"drawing/chart",enable:function(a){return w(a,1)},get:function(a){return x(a,1)},set:function(a){return y(o("chart"),1,a)}},a["drawing/charttype"]={parent:"drawing/chart",get:function(a){return a?a.getChartTypeForGui():null},set:v},a["drawing/chart/attributes"]={parent:"drawing/chart",get:function(a){return a?a.getMergedAttributeSet(!0):null},set:function(a){this.getParentValue().setAttributes(a)}},a["drawing/chartvarycolor"]={parent:["drawing/chart","drawing/chart/attributes"],enable:function(a){return a.isVaryColorEnabled()},get:function(a,b){return b?b.chart.varyColors:null},set:function(a){this.getParentValue().changeVaryColors(a)}},a["drawing/chartdatalabel"]={parent:["drawing/chart","drawing/chart/attributes"],get:function(a,b){return b?b.chart.dataLabel:!1},set:function(a){return p(this.getParentValue(),e.SET_DRAWING_ATTRIBUTES,{attrs:{chart:{dataLabel:a}}})}},a["drawing/chartmarkeronly"]={parent:["drawing/chart"],enable:function(a){var b=a?a.getMergedAttributeSet(!0).chart:{};return"line2d"===b.type||"scatter2d"===b.type},get:function(a){return a?a.isMarkerOnly():!1},set:function(a){this.getParentValue().setMarkerOnly(a)}},a["drawing/chartcolorset"]={parent:"drawing/chart",get:function(a){return a?a.getColorSet():null},set:function(a){this.getParentValue().changeColorSet(a)}},a["drawing/chartstyleset"]={parent:"drawing/chart",get:function(a){return a?a.getStyleSet():null},set:function(a){this.getParentValue().changeStyleSet(a)}},a["drawing/chartsource"]={parent:"drawing/chart",get:function(){return D},set:u},a["drawing/chartlegend/pos"]={parent:"drawing/chart",get:function(a){return a?a.getLegendModel().getMergedAttributeSet(!0).legend.pos:null},set:function(a){return p(this.getParentValue(),e.SET_CHART_LEGEND_ATTRIBUTES,{attrs:{legend:{pos:a}}})}},a["drawing/chart/axes/enabled"]={parent:"drawing/chart",enable:function(a){return a.isAxesEnabled()}},A("x",a),A("y",a),a["drawing/chart/title/model"]={parent:"drawing/chart",get:function(a){return a?a.getTitleModel("main"):null}},a["drawing/chart/title/attributes"]={parent:["drawing/chart/title/model","drawing/chart"],get:function(a){return a?a.getMergedAttributeSet(!0):null},set:function(a){return s(this.getParentValue(1),"main",a)}},a["drawing/chart/title/text"]={parent:["drawing/chart/title/attributes","drawing/chart"],get:function(a){return r(a)},set:function(a){return t(this.getParentValue(1),"main",a)}},a["drawing/chart/title/delete"]={parent:["drawing/chart/title/text","drawing/chart"],enable:function(){return this.getValue().length>0},set:function(){return t(this.getParentValue(1),"main","")}},a["drawing/border/style"]={parent:"drawing/image",get:function(a){return c.getPresetBorder(a?a.getMergedAttributeSet(!0).line:null)},set:function(a){var b=this.getParentValue().getMergedAttributeSet(!0),d={line:c.resolvePresetBorder(a)};return"auto"===b.line.color.type&&(d.line.color={type:"rgb",value:"000000"}),k.changeDrawings(d)}},a["drawing/border/color"]={parent:"drawing/image",get:function(a){return a?a.getMergedAttributeSet(!0).line.color:b.AUTO},set:function(a){var b=this.getParentValue().getMergedAttributeSet(!0),c={line:{color:a}};return"solid"!==b.line.type&&(c.line.type="solid"),k.changeDrawings(c)}},C.registerDefinitions(a)}var C=this,D=!1,E=null,F=[],G=null;B(),this.listenTo(k,"change:selection",m),this.registerDestructor(function(){C=i=j=k=E=F=null})}return i});