define("io.ox/office/spreadsheet/model/formula/formulacompiler",["io.ox/office/tk/utils","io.ox/office/baseframework/model/modelobject","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/utils/formulaerror","io.ox/office/spreadsheet/model/formula/parser/tokens"],function(a,b,c,d,e,f){"use strict";function g(a,b){return _.isObject(a)&&a.isType("op")&&a.getValue()in m[b]}function h(a,b,c){this.token=a,this.operands=b||null,this.descriptor=c||null,this.recalc=null,this.signature=null,this.error=null,this._initialize()}var i=c.ErrorCode,j=f.LiteralToken,k=f.OperatorToken,l=f.SheetRefToken,m={cmp:a.makeSet(["eq","ne","lt","le","gt","ge"]),con:a.makeSet(["con"]),pct:a.makeSet(["pct"]),add:a.makeSet(["add","sub"]),mul:a.makeSet(["mul","div"]),pow:a.makeSet(["pow"]),list:a.makeSet(["list"]),isect:a.makeSet(["isect"]),range:a.makeSet(["range"])};h.prototype._ensure=function(a,b,c){return a||(this.error=new e(b,c)),!!a},h.prototype._initialize=function(){if(this.operands&&this.descriptor){this.recalc=this.operands.reduce(function(a,b){return d.getRecalcMode(a,b.recalc)},this.descriptor.recalc);var b=this.descriptor.minParams,c=0,e=0;"maxParams"in this.descriptor?(c=this.descriptor.maxParams,e=1):(e="repeatParams"in this.descriptor?this.descriptor.repeatParams:1,c=b+a.roundDown(d.MAX_PARAM_COUNT-b,e));var f=this.operands.length;if(this._ensure(f>=b,"not enough parameters","missing")&&this._ensure(c>=f,"too many parameters","unexpected")&&this._ensure((f-b)%e===0,"not enough parameters","missing")){var g=this.descriptor.signature;(0===this.operands.length||g.length>0)&&(this.signature=_.times(this.operands.length,function(a){return g.length<=a&&(a=g.length-e+(a-g.length)%e),g[a]}))}}},h.prototype.isOperator=function(){return!!this.operands},h.prototype.toString=function(){return this.token+(this.isOperator()?":"+this.operands.length:"")};var n=b.extend({constructor:function(a){var c=a.getFormulaResource().getOperatorCollection(),f=a.getFormulaResource().getFunctionCollection();b.call(this,a),this.compileTokens=d.profileMethod("FormulaCompiler.compileTokens()",function(a){function b(){return a[F]||null}function m(){var a=b();return a&&(F+=1),a}function n(){for(var a=m();a&&a.isType("ws");)a=m();return a}function o(){var a=n();if(a)return a;throw new e("unexpected end of formula","missing")}function p(a,b){if(H.length<b)throw new e("invalid operand stack size","missing");var d=b>0?H.splice(-b):[],g=a.isType("op")?c.get(a.getValue()):a.isType("func")?f.get(a.getValue()):null;H.push(new h(a,d,g))}function q(a){H.push(new h(a))}function r(a,b,c){var d=a(n());return p(b,c),d}function s(a,b){var c=G;return G=b,a=t(a),G=c,a}function t(a){for(a=u(a);g(a,"cmp");)a=r(u,a,2);return a}function u(a){for(a=v(a);g(a,"con");)a=r(v,a,2);return a}function v(a){for(a=w(a);g(a,"add");)a=r(w,a,2);return a}function w(a){for(a=x(a);g(a,"mul");)a=r(x,a,2);return a}function x(a){for(a=y(a);g(a,"pow");)a=r(y,a,2);return a}function y(a){for(a=g(a,"add")?r(y,a,1):z(a);g(a,"pct");)p(a,1),a=n();return a}function z(a){for(a=A(a);a&&(g(a,"list")||!G&&a.isType("sep"));)a.isType("sep")&&(a=new k("list")),a=r(A,a,2);return a}function A(a){for(a=B(a);g(a,"isect");)a=r(B,a,2);return a}function B(a){for(a=C(a);g(a,"range");)a=r(C,a,2);return a}function C(a){if(!a)throw new e("unexpected end of formula","missing");if(a instanceof l&&a.hasSheetError())throw new e("invalid sheet name","unexpected");if(a.matchesType(/^(lit|mat|ref|name|table)$/))return q(a),n();if(a.isType("open"))return D();if(a.isType("func")||a.isType("macro"))return E(a);throw new e("operand expected","unexpected")}function D(){var a=s(o());if(a){if(!a.isType("close"))throw new e("closing parenthesis expected","unexpected")}else I+=1;return n()}function E(a){for(var b=a,c="start",d=0;"end"!==c;)switch(c){case"start":if(a=o(),!a.isType("open"))throw new e("opening parenthesis expected","unexpected");c="open";break;case"open":a=n(),a||(I+=1),c=!a||a.isType("close")?"close":"param";break;case"param":if(d+=1,a||(I+=1),!a||a.matchesType(/^(sep|close)$/))q(new j(null));else if(a=s(a,!0)){if(!a.matchesType(/^(sep|close)$/))throw new e("parameter separator expected","unexpected")}else I+=1;c=a?a.getType():"close";break;case"sep":a=n(),c="param";break;case"close":p(b,d),c="end"}return n()}var F=0,G=!1,H=[],I=0;try{d.logTokens("compiling",a);var J=s(o());if(0===H.length)throw new e("missing formula expression","missing");if(H.length>1)throw new e("invalid formula expression","unexpected");if(J||F<a.length)throw new e("unexpected garbage at end of formula","unexpected");d.withLogging(function(){function a(c){b.push(c),c.isOperator()&&c.operands.forEach(a)}var b=[];a(H[0]),d.logTokens("compiled",b)})}catch(K){if(K instanceof e)return d.warn("error: "+K.message+", index="+(F-1)),{root:new h(new j(i.NA)),error:K.type,missingClose:0};throw K}return{root:H[0],error:null,missingClose:I}}),this.registerDestructor(function(){a=c=f=null})}});return n});