define("io.ox/office/spreadsheet/model/formula/formulacontext",["io.ox/office/tk/utils","io.ox/office/tk/utils/iteratorutils","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/utils/complex","io.ox/office/spreadsheet/model/formula/utils/matrix","io.ox/office/spreadsheet/model/formula/utils/operand"],function(a,b,c,d,e,f,g){"use strict";function h(a){return a.forEach(d.throwErrorCode),a}function i(a,b){return a.forEach(function(a){if(d.throwErrorCode(a),!b(a))throw q.VALUE}),a}function j(a){if(a.empty())throw q.NULL;if(!a.singleSheet())throw q.VALUE;return a}function k(a){return a instanceof g?a.getType():a instanceof f?"mat":a instanceof s||a instanceof t?"ref":"val"}function l(a){return a instanceof g?a.getSize():a instanceof f?a.size():a instanceof s||a instanceof t?a.cells():1}function m(b,c){return a.getStringOption(c,k(b)+"Mode","convert")}function n(a){var c=0;return b.createTransformIterator(a,function(a,b){return null===a?null:(b.index=c,c+=1,b)})}function o(a){var c=b.createParallelIterator(a,function(a,b){return b.offset});return b.createTransformIterator(c,function(a,b){if(b.complete){var c=b.results[0];return{value:a,offset:b.offset,col:c.col,row:c.row,results:b.results}}})}function p(b,c){this._formulaInterpreter=b.getFormulaInterpreter(),this._dependencyManager=b.getDependencyManager(),this._refSheet=a.getIntegerOption(c,"refSheet",null),this._targetAddress=a.getOption(c,"targetAddress",r.A1),this._detectCircular=a.getBooleanOption(c,"detectCircular",!1),this._recalcDirty=a.getOption(c,"recalcDirty",!1),this._STANDARD_FORMAT=b.getNumberFormatter().getParsedFormat(0),this._MAX_STRING_LEN="odf"===b.getApp().getFileFormat()?65535:32767,this._END_EVAL_TIME=_.now()+d.MAX_EVAL_TIME,this._resolverStack=[],this._operandResolver=null,this._matRow=0,this._matCol=0,this.app=b.getApp(),this.docModel=b,this.fileFormat=this.app.getFileFormat(),this.formulaResource=b.getFormulaResource(),this.formulaGrammar=b.getFormulaGrammar("ui"),this.numberFormatter=b.getNumberFormatter()}var q=c.ErrorCode,r=c.Address,s=c.Range3D,t=c.Range3DArray,u=d.ScalarType;return p.prototype._getCellValue=function(a,b){if(!this._recalcDirty)return a.getCellCollection().getCellValue(b);var c=this._dependencyManager.getCellValue(a,b);return this._END_EVAL_TIME+=c.time,c.value},p.prototype._checkCircularReference=function(a){if(this._detectCircular&&_.isNumber(this._refSheet)&&a.containsSheet(this._refSheet)&&a.containsAddress(this._targetAddress))throw d.CIRCULAR_ERROR;return a},p.prototype._createOperandIterator=function(c,e,h){function i(a,b,c,f,g,h){return r||d.throwErrorCode(a),(w+=1)%1e3===0&&o.checkEvalTime(),a=e.call(o,a),!h&&u&&(h=o._STANDARD_FORMAT),{value:a,format:h,offset:b+c*g+f,col:f,row:g}}function j(a){return p||null!==a?b.createSingleIterator(i(a,0,1,0,0,null)):b.ALWAYS_DONE_ITERATOR}function k(a){var c=a.cols();return b.createTransformIterator(a.iterator(),function(a,b){return i(a,0,c,b.col,b.row,null)})}function l(a,c,d){var e=c.start[0],f=c.start[1],g=c.cols(),h=a.getCellCollection(),j=h.createAddressIterator(c,{type:q?"all":"value",visible:v});return b.createTransformIterator(j,function(b){var c=u?h.getCellParsedFormat(b):null;return i(o._getCellValue(a,b),d,g,b[0]-e,b[1]-f,c)})}function m(a,c){var d=a.toRange(),e=d.cells(),f=o.docModel.createSheetIntervalIterator(a.sheet1,a.sheet2,{types:"worksheet"});return b.createNestedIterator(f,function(a){var b=c;return c+=e,l(a,d,b)})}function n(c){if(a.getBooleanOption(h,"complexRef",!1)){var d=t.iterator(c),e=0;return b.createNestedIterator(d,function(a){o._checkCircularReference(a);var b=e;return e+=a.cells(),m(a,b)})}return m(o.convertToValueRange(c),0)}var o=this,p=a.getBooleanOption(h,"emptyParam",!1),q=a.getBooleanOption(h,"emptyCells",!1),r=a.getBooleanOption(h,"acceptErrors",!1),u=a.getOption(h,"collectFormats",!1),v=a.getOption(h,"visible",!1),w=0;if(c instanceof g){switch(c.getType()){case"val":return j(c.getValue());case"mat":return k(c.getMatrix());case"ref":return n(c.getRanges())}d.throwInternal("FormulaContext._createOperandIterator(): invalid operand type")}return c instanceof f?k(c):c instanceof s||c instanceof t?n(c):_.isUndefined(c)?b.ALWAYS_DONE_ITERATOR:j(c)},p.prototype._iterateValues=function(a,c){var d=0;return b.forEach(a,function(a,b){c.call(this,a,d,b.offset,b.col,b.row,b.format),d+=1},this),d},p.prototype._aggregateValues=function(b,c,e,f,g,h){var i=c,j=0,k=0,m=a.getBooleanOption(h,"collectFormats",!0),n=m?this._STANDARD_FORMAT:null;return _.each(b,function(a){j+=e.call(this,a,function(a,b,c,e,g,h){var l=j+b,m=k+c;i=f.call(this,i,a,l,m),n&&(n=d.combineParsedFormats(n,h))},h),k+=l(a)},this),i=d.throwErrorCode(g.call(this,i,j,k)),n?this.createOperand(i,{format:n}):i},p.prototype.pushOperandResolver=function(a,b,c){return this._resolverStack.push({resolver:this._operandResolver,row:this._matRow,col:this._matCol}),this._operandResolver=a,this._matRow=b,this._matCol=c,this},p.prototype.popOperandResolver=function(){var a=this._resolverStack.pop();return this._operandResolver=a.resolver,this._matRow=a.row,this._matCol=a.col,this},p.prototype.convertToNumber=function(a,b){if(d.throwErrorCode(a),a=this.numberFormatter.convertScalarToNumber(a,b),null===a)throw q.VALUE;return a},p.prototype.convertToDate=function(a,b){if(d.throwErrorCode(a),a=this.numberFormatter.convertScalarToDate(a,b),null===a)throw q.VALUE;return a},p.prototype.convertToString=function(a){if(d.throwErrorCode(a),a=this.numberFormatter.convertScalarToString(a,c.MAX_LENGTH_STANDARD_FORMULA),null===a)throw q.VALUE;return a},p.prototype.convertToBoolean=function(a){if(d.throwErrorCode(a),a=this.numberFormatter.convertScalarToBoolean(a),null===a)throw q.VALUE;return a},p.prototype.convertToComplex=function(a){if(d.throwErrorCode(a),_.isBoolean(a))throw q.VALUE;if(a instanceof Date&&(a=this.convertToNumber(a)),_.isNumber(a)&&_.isFinite(a)?a=new e(a,0):_.isString(a)?a=this.numberFormatter.convertStringToComplex(a):null===a&&(a=new e(0,0)),a instanceof e)return a;throw q.NUM},p.prototype.convertToRange=function(b,c){if(b=t.get(b),b.empty())throw q.NULL;if(b.length>1)throw a.getBooleanOption(c,"valueError",!1)?q.VALUE:q.REF;if(!a.getBooleanOption(c,"multiSheet",!1)&&!b[0].singleSheet())throw q.VALUE;return b[0]},p.prototype.convertToValueRange=function(a){return this._checkCircularReference(this.convertToRange(a,{valueError:!0}))},p.prototype.convertOperandToValue=function(a,b){switch(b){case"any":case"any:lazy":return a;case"val":return d.throwErrorCode(a.getValue(this._matRow,this._matCol));case"val:num":return this.convertToNumber(a.getValue(this._matRow,this._matCol));case"val:int":return this.convertToNumber(a.getValue(this._matRow,this._matCol),!0);case"val:date":return this.convertToDate(a.getValue(this._matRow,this._matCol));case"val:day":return this.convertToDate(a.getValue(this._matRow,this._matCol),!0);case"val:str":return this.convertToString(a.getValue(this._matRow,this._matCol));case"val:bool":return this.convertToBoolean(a.getValue(this._matRow,this._matCol));case"val:comp":return this.convertToComplex(a.getValue(this._matRow,this._matCol));case"val:any":return a.getValue(this._matRow,this._matCol);case"mat":return h(a.getMatrix());case"mat:num":return i(a.getMatrix(),_.isNumber);case"mat:str":return i(a.getMatrix(),_.isString);case"mat:bool":return i(a.getMatrix(),_.isBoolean);case"mat:any":return a.getMatrix();case"ref":return a.getRanges();case"ref:sheet":return j(a.getRanges());case"ref:single":return this.convertToRange(a.getRanges());case"ref:multi":return this.convertToRange(a.getRanges(),{multiSheet:!0})}d.throwInternal('FormulaContext.convertOperandToValue(): unknown type specifier: "'+b+'"')},p.prototype.compareScalars=function(a,b){return this._formulaInterpreter.compareScalars(a,b)},p.prototype.validateValue=function(a){if(a instanceof Date)return a=this.numberFormatter.convertDateToNumber(a),_.isNumber(a)?a:q.NUM;if(a instanceof e){if(!_.isFinite(a.real)||!_.isFinite(a.imag))return q.NUM;d.isZero(a.real)&&(a.real=0),d.isZero(a.imag)&&(a.imag=0),a=this.numberFormatter.convertComplexToString(a,c.MAX_LENGTH_STANDARD_FORMULA)}return _.isNumber(a)?_.isFinite(a)?d.isZero(a)?0:a:q.NUM:_.isString(a)?a.length<=this._MAX_STRING_LEN?a:q.VALUE:a},p.prototype.checkStringLength=function(a){if(0>a||a>this._MAX_STRING_LEN)throw q.VALUE},p.prototype.checkStringIndex=function(a){if(1>a||a>this._MAX_STRING_LEN)throw q.VALUE},p.prototype.concatStrings=function(){var a=_.reduce(arguments,function(a,b){return a+b},"");return this.checkStringLength(a.length),a},p.prototype.repeatString=function(b,c){return this.checkStringLength(b.length*c),0===b.length?"":a.repeatString(b,c)},p.prototype.checkComplexUnits=function(a,b){if(_.isString(a.unit)&&_.isString(b.unit)&&a.unit!==b.unit)throw q.VALUE},p.prototype.checkCellRef=function(a,b){var c=b&&!a.absCol?Math.abs(a.col):a.col,d=b&&!a.absRow?Math.abs(a.row):a.row;if(!this.docModel.isValidAddress(new r(c,d)))throw q.VALUE},p.prototype.checkEvalTime=d.isLoggingActive()?function(){if(_.now()>this._END_EVAL_TIME)throw d.UNSUPPORTED_ERROR}:_.noop,p.prototype.getOperandCount=function(){return this._operandResolver.size()},p.prototype.getOperand=function(a,b){var c=this._operandResolver.resolve(a);if(!c)throw q.NA;return b?this.convertOperandToValue(c,b):c},p.prototype.getOperandValue=function(a){var b=this._operandResolver.resolve(a);if(!b)throw q.NA;return b.getRawValue()},p.prototype.isMissingOperand=function(a){return a>=this._operandResolver.size()},p.prototype.isEmptyOperand=function(a){var b=this._operandResolver.resolve(a);return!!b&&b.isEmpty()},p.prototype.isMissingOrEmptyOperand=function(a){return this.isMissingOperand(a)||this.isEmptyOperand(a)},p.prototype.getOperands=function(a){var b=this._operandResolver,c=_.times(b.size()-a,function(c){return b.resolve(a+c)});if(c.length>0)return c;throw q.VALUE},p.prototype.iterateOperands=function(a,b){return this.getOperands(a).forEach(function(c,d){b.call(this,c,a+d)},this),this},p.prototype.createOperand=function(a,b){return new g(this,a,b)},p.prototype.isRefSheet=function(a){var b=this._refSheet;return null!==b&&b>=0&&b===a},p.prototype.getRefSheet=function(){if("number"!=typeof this._refSheet)throw q.REF;return this._refSheet},p.prototype.isRefAddress=function(a){return this._targetAddress.equals(a)},p.prototype.getRefAddress=function(){return this._targetAddress.clone()},p.prototype.getCellValue=function(a,b){var c=this.docModel.getSheetModel(a);if(!c)throw q.REF;return this._getCellValue(c,b)},p.prototype.getCellMatrix=function(a,c){var e=this.docModel.getSheetModel(a);if(!e)throw q.REF;var g=c.rows(),h=c.cols();d.ensureMatrixSize(g,h);var i=f.create(g,h,null),j=e.getCellCollection().createAddressIterator(c,{type:"value"});return b.forEach(j,function(a){i.set(a[1]-c.start[1],a[0]-c.start[0],this._getCellValue(e,a))},this),i},p.prototype.getCellFormula=function(a,b){var c=this.docModel.getSheetModel(a);if(!c)throw q.REF;return c.getCellCollection().getCellFormula(b,"ui")},p.prototype.createScalarIterator=function(a,b){return this._createOperandIterator(a,_.identity,b)},p.prototype.iterateScalars=function(a,b,c){var d=this.createScalarIterator(a,c);return this._iterateValues(d,b)},p.prototype.getScalarsAsArray=function(a,c){return b.toArray(this.createScalarIterator(a,c))},p.prototype.createNumberIterator=function(b,c){var e=m(b,c),f=a.getBooleanOption(c,"skipErrors",!1),g=a.getBooleanOption(c,"floor",!1),h=a.getBooleanOption(c,"dates",!1),i=this._createOperandIterator(b,function(a){if(f&&a instanceof q)return null;switch(e){case"convert":a=this.convertToNumber(a,g);break;case"rconvert":if(_.isBoolean(a))throw q.VALUE;a=this.convertToNumber(a,g);break;case"exact":if(_.isString(a)||_.isBoolean(a)||null===a)throw q.VALUE;a=this.convertToNumber(a,g);break;case"skip":_.isNumber(a)?g&&(a=Math.floor(a)):a=null;break;case"zero":a=_.isString(a)?0:this.convertToNumber(a,g);break;default:d.throwInternal('FormulaContext.createNumberIterator(): unknown conversion mode: "'+e+'"')}return h&&_.isNumber(a)?this.convertToDate(a):a},_.extend({},c,{emptyCells:!1,acceptErrors:f}));return n(i)},p.prototype.iterateNumbers=function(a,b,c){var d=this.createNumberIterator(a,c);return this._iterateValues(d,b)},p.prototype.getNumbersAsArray=function(a,c){return b.toArray(this.createNumberIterator(a,c))},p.prototype.aggregateNumbers=function(a,b,c,d,e){return this._aggregateValues(a,b,this.iterateNumbers,c,d,e)},p.prototype.aggregateNumbersAsArray=function(a,b,c){function d(a,b){return f.push(b),a+b}function e(a,c){return b.call(this,f,a,c)}var f=[];return this.aggregateNumbers(a,0,d,e,c)},p.prototype.aggregateNumbersParallel=function(c,e,f,h,i){c=_.map(c,function(a){return a instanceof g?a:this.createOperand(a)},this);var j=a.getStringOption(i,"checkSize","exact");if(c.length>1&&"none"!==j){var k="size"!==j,l=c[0].getDimensions(),m=l.rows*l.cols;c.forEach(function(b,c){if(0!==c){var d=b.getDimensions();if(k?l.cols!==d.cols||l.rows!==d.rows:m!==d.cols*d.rows)throw a.getOption(i,"sizeMismatchError",q.VALUE)}})}var n=c.map(function(a){return this.createNumberIterator(a,i)},this),p=e,r=0,s=o(n);return b.forEach(s,function(a){p=f.call(this,p,a,r),r+=1}),d.throwErrorCode(h.call(this,p,r))},p.prototype.aggregateNumbersParallelAsArrays=function(a,b,c){function d(a,b){return f.push(b),b.forEach(function(b,c){a[c]+=b}),a}function e(a,c){return b.call(this,f,a,c)}var f=[],g=_.times(a.length,_.constant(0));return this.aggregateNumbersParallel(a,g,d,e,c)},p.prototype.createStringIterator=function(a,b){var c=m(a,b),e=this._createOperandIterator(a,function(a){switch(c){case"convert":return this.convertToString(a);case"skip":return"string"==typeof a?a:null;default:d.throwInternal('FormulaContext.createStringIterator(): unknown conversion mode: "'+c+'"')}},_.extend({},b,{emptyCells:!1,acceptErrors:!1}));return n(e)},p.prototype.iterateStrings=function(a,b,c){var d=this.createStringIterator(a,c);return this._iterateValues(d,b)},p.prototype.aggregateStrings=function(a,b,c,d,e){return this._aggregateValues(a,b,this.iterateStrings,c,d,e)},p.prototype.createBooleanIterator=function(a,b){var c=m(a,b),e=this._createOperandIterator(a,function(a){switch(c){case"convert":return this.convertToBoolean(a);case"skip":return _.isString(a)?null:this.convertToBoolean(a);default:d.throwInternal('FormulaContext.createBooleanIterator(): unknown conversion mode: "'+c+'"')}},_.extend({},b,{emptyCells:!1,acceptErrors:!1}));return n(e)},p.prototype.iterateBooleans=function(a,b,c){var d=this.createBooleanIterator(a,c);return this._iterateValues(d,b)},p.prototype.aggregateBooleans=function(a,b,c,d,e){return this._aggregateValues(a,b,this.iterateBooleans,c,d,e)},p.prototype.convertPatternToRegExp=function(a,b){return a=_.escapeRegExp(a).replace(/(^|[^~])\\\*/g,"$1.*").replace(/(^|[^~])\\\?/g,"$1.").replace(/~(\\[*?])/g,"$1"),b&&(a="^"+a+"$"),new RegExp(a,"i")},p.prototype.createFilterMatcher=function(a){var b=this.numberFormatter,c=null,e=null,f=null;if(_.isString(a)){var g=/^(<=|>=|<>|<|>|=)?(.*)$/.exec(a);c=_.isString(g[1])?g[1]:"",e=b.parseValue(g[2],{keepApos:!0})}else c="",e=a;if(f=""===c||"="===c,null===e)return function(a){return 0===(_.isString(a)?b.parseValue(a):a)};if(""===e)switch(c){case"":return function(a){return""===a||null===a};case"=":return function(a){return null===a};case"<>":return function(a){return null!==a};default:return _.constant(!1)}var h=d.getScalarType(e);if(h===u.STRING&&/[*?]/.test(e)&&(f||"<>"===c)){var i=this.convertPatternToRegExp(e,!0);return function(a){return f===(_.isString(a)&&i.test(a))}}return h===u.STRING&&(e=e.toUpperCase()),function(a){if(f&&"string"==typeof a){var g=b.parseValue(a);"number"==typeof g&&(a=g)}var i=null!==a&&h===d.getScalarType(a),j=i?d.compareScalars(a,e):Number.NaN;switch(c){case"":case"=":return isFinite(j)&&0===j;case"<>":return!isFinite(j)||0!==j;case"<":return isFinite(j)&&0>j;case"<=":return isFinite(j)&&0>=j;case">":return isFinite(j)&&j>0;case">=":return isFinite(j)&&j>=0}d.throwInternal("FormulaContext.comparisonMatcher(): invalid operator")}},p.prototype.aggregateFiltered=function(a,c,e,f,g){0===a.length&&d.throwInternal("FormulaContext.aggregateFiltered(): invalid number of operands");var h=0,i=0;if(a.forEach(function(a,b){var c=a.range;if(0===b)h=c.cols(),i=c.rows();else if(h!==c.cols()||i!==c.rows())throw q.VALUE}),c&&(h!==c.cols()||i!==c.rows()))throw q.VALUE;var j=a.map(function(a){var c=this.createFilterMatcher(a.criterion),d=c(null),e=this.createScalarIterator(a.range,{emptyCells:d,acceptErrors:!0,complexRef:!1});return b.createFilterIterator(e,c)},this);c&&j.push(this.createNumberIterator(c,{refMode:"skip",acceptErrors:!0,complexRef:!1}));var k=e,l=0,m=o(j);return b.forEach(m,function(a){if(l+=1,c){var b=_.last(a);d.throwErrorCode(b),k=f.call(this,k,b)}},this),c?d.throwErrorCode(g.call(this,k,l)):l},p});