define("io.ox/office/spreadsheet/model/formula/formulainterpreter",["io.ox/office/tk/utils","io.ox/office/tk/object/baseobject","io.ox/office/baseframework/model/modelobject","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/presetformattable","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/formulacontext","io.ox/office/spreadsheet/model/formula/utils/formulaerror","io.ox/office/spreadsheet/model/formula/utils/complex","io.ox/office/spreadsheet/model/formula/utils/matrix","io.ox/office/spreadsheet/model/formula/utils/operand"],function(a,b,c,d,e,f,g,h,i,j,k){"use strict";var l=d.ErrorCode,m=d.Address,n=d.Range3D,o=d.Range3DArray,p=b.extend({constructor:function(c,d,p){function q(){this._operandArray=[]}function r(a){var b=a.getRange3D(p);return b?new o(b):l.REF}function s(a,b){var c=b.resolveNameModel(E);if(!c)return l.NAME;var d={refSheet:E,refAddress:m.A1,targetAddress:F,recalcDirty:G};return c.getTokenArray().interpretFormula(a,d).value}function t(a){var b=a.getRange3D(F);return b?new o(b):l.REF}function u(a,b){if("ref"===b&&"ref"!==a&&"any"!==a)throw new h("expected reference token","reference")}function v(a){if(null===a||a instanceof Date||a instanceof i||a instanceof l)return!0;var b=typeof a;return"number"===b||"string"===b||"boolean"===b}function w(a){return a instanceof j}function x(a){return a instanceof n||a instanceof o}function y(a,b){var c=a.token,d=null,e=null;switch(f.log("> resolving operand token: "+c),c.getType()){case"lit":e=c.getValue(),d=e===l.REF?"ref":"val";break;case"mat":e=c.getMatrix(),d="mat";break;case"ref":e=r(c),d="ref";break;case"name":e=s(b,c),d="any";break;case"table":e=t(c),d="ref";break;default:f.throwInternal('InterpreterInstance.makeTokenOperand(): unknown token type: "'+c.getType()+'"')}return u(d,b),H.createOperand(e)}function z(a,b){if("combine"===b){for(var c=I,d=0;c&&d<a.size();d+=1){var g=a.get(d),h=g&&g.getFormat()||I;c=f.combineParsedFormats(c,h)}return c}var i=null;switch(b){case"percent":i=e.getPercentId(!0);break;case"currency":i=D.getCurrencyCode({red:!0});break;case"fraction":i=e.getFractionId(!0);break;case"date":i=e.SYSTEM_DATE_ID;break;case"time":i=e.getTimeId(null,!0);break;case"datetime":i=e.SYSTEM_DATETIME_ID}return null===i?null:D.getParsedFormat(i)}function A(a,b,c,d,e){var g=null;try{H.pushOperandResolver(c,d,e);var h=b.map(function(a,b){return"any:lazy"===a.typeSpec?null:H.getOperand(b,a.typeSpec)});f.logTokens("  resolving with parameters",h),g=a.resolve.apply(H,h);var i=g instanceof k?g.getRawValue():g,j=!1;switch(a.type){case"val":j=v(i);break;case"mat":j=w(i);break;case"ref":j=x(i);break;case"any":j=v(i)||w(i)||x(i);break;default:f.throwInternal('InterpreterInstance.resolveOperator(): unknown type identifier: "'+a.type+'"')}j||f.throwInternal("InterpreterInstance.resolveOperator(): "+a.name+": operator result type does not match operator return type"),H.checkEvalTime()}catch(m){if(!(m instanceof l))throw m;g=m}finally{H.popOperandResolver()}return g}function B(a,b){if(a.error)throw a.error;var c=a.token,d=a.descriptor,e=a.signature,g=new q,h=0,i=0,k=null;if(f.log("> processing operator "+c+" with "+a.operands.length+" parameters"),!d)return H.createOperand(l.NAME);if(u(d.type,b),!_.isFunction(d.resolve))return f.warn('InterpreterInstance.processOperator(): unsupported operator or function "'+c+'"'),H.createOperand(f.UNSUPPORTED_ERROR);if(e.forEach(function(c,e){var f=c.baseType;"mat"===b&&"val"===c.baseType&&"val"===d.type&&(f="mat"),g.push(a.operands[e],f)}),"val"===d.type&&e.forEach(function(a,c){if("val"===a.baseType){var d=g.resolve(c);if("mat"===b&&d.isReference()&&(d=g._operandArray[c].operand=H.createOperand(d.getMatrix())),d.isMatrix()){var e=d.getMatrix();h=Math.max(h,e.rows()),i=Math.max(i,e.cols())}}}),h*i>0){if(!f.isValidMatrixSize(h,i))return H.createOperand(f.UNSUPPORTED_ERROR);f.info("  process as "+h+"x"+i+" matrix"),k=j.generate(h,i,function(a,b){return A(d,e,g,a,b)})}else k=A(d,e,g,0,0);var m=d.format?z(g,d.format):null;return H.createOperand(k,{format:m})}function C(a,b){var c=a.isOperator()?B(a,b):y(a,b);return f.log("< result of "+a+": "+c),c}var D=c.getNumberFormatter(),E=a.getIntegerOption(p,"refSheet",null),F=a.getOption(p,"targetAddress",m.A1),G=a.getOption(p,"recalcDirty",!1),H=new g(c,p),I=D.getParsedFormat(0);b.call(this),q.prototype.push=function(a,b){this._operandArray.push({tokenNode:a,contextType:b})},q.prototype.size=function(){return this._operandArray.length},q.prototype.get=function(a){var b=this._operandArray[a];return b&&b.operand||null},q.prototype.resolve=function(a){var b=this._operandArray[a];return b?b.operand||(b.operand=C(b.tokenNode,b.contextType)):null},this.getResult=function(a){return C(d,a)},this.registerDestructor(function(){c=d=p=D=H=null})}}),q=c.extend({constructor:function(a){var b={withCase:"odf"===a.getApp().getFileFormat(),nullMode:"convert"};c.call(this,a),this.compareScalars=function(a,c){return f.compareScalars(a,c,b)},this.createResult=function(a,b){if(a instanceof l&&a.internal)return{type:"warn",code:a.key,value:a.value};var c=b?b.getFormat():null,d=b?b.getURL():null,e={type:"valid",value:a};return null!==c&&(e.format=c),null!==d&&(e.url=d),e},this.createErrorResult=function(a){return{type:"error",code:a,value:l.NA}},this.interpretTokens=function(b,c,d){var e=new p(a,c,d),g=null,i=null;try{switch(f.takeTime("FormulaInterpreter.interpretTokens(): contextType="+b,function(){g=e.getResult(b)}),b="any"===b?g.getType():b){case"val":i=g.getValue(),null===i&&(i=0);break;case"mat":i=g.getMatrix();break;case"ref":i=g.getRanges();break;default:f.throwInternal('FormulaInterpreter.interpretTokens(): unknown context type: "'+b+'"')}f.throwErrorCode(i),i=this.createResult(i,g)}catch(j){if(j instanceof h)f.warn("  error: "+j.msg),i=this.createErrorResult(j.type);else{if(!(j instanceof l))throw j;i=this.createResult(j)}}finally{e.destroy()}return f.info("result: type="+i.type+" code="+i.code+" value="+f.valueToString(i.value)+" format="+i.format+" url="+i.url),i},this.registerDestructor(function(){a=null})}});return q});