define("io.ox/office/spreadsheet/model/formula/formulautils",["io.ox/office/tk/utils","io.ox/office/tk/utils/logger","io.ox/office/spreadsheet/utils/errorcode"],function(a,b,c){"use strict";function d(a,b){var d=new c(a);return d.internal=!0,d.value=b,d}function e(a){switch(typeof a){case"number":return 0;case"string":return"";case"boolean":return!1}return null}function f(a,b){return a===b?0:b>a?-1:1}function g(b){var c=a.normalizeNumber(b);return n(1e14*c.mant)*y.pow10(c.exp-14)}function h(a,b){if(a===b)return!0;var c=y.isZero(a),d=y.isZero(b);if(c||d)return c===d;if(0>a!=0>b)return!1;var e=o(a/b-1);return!isFinite(e)||e>1e-14?!1:g(a)===g(b)}function i(a,b,c){return c?a===b:a.toUpperCase()===b.toUpperCase()}function j(a){for(var b=a,c=1,d=3,e=1,f=-1,g=0;w>=c&&b!==g;c+=1,d+=2,e*=c,f=-f)g=b,b+=f*p(a,d)/d/e;return 2*b/u}function k(a){for(var b=0,c=w,d=c%2+1;c>=1;c-=1,d=3-d)b=c/(d*a+b);return r(-a*a)/u/(a+b)}var l=Math.floor,m=Math.ceil,n=Math.round,o=Math.abs,p=Math.pow,q=Math.sqrt,r=Math.exp,s=Math.log,t=Math.PI,u=q(t),v=Math.LN10,w=25,x=1.9785,y={};return b.extend(y,{enable:"spreadsheet:log-formulas",prefix:"FMLA"}),y.MAX_PARAM_COUNT=254,y.MAX_MATRIX_ROW_COUNT=16,y.MAX_MATRIX_COL_COUNT=16,y.MAX_REF_LIST_SIZE=1024,y.MAX_EVAL_TIME=2e3,y.ScalarType={NULL:0,NUMBER:1,STRING:2,BOOLEAN:3,ERROR:4,NULL_MAX:5},y.UNSUPPORTED_ERROR=d("unsupported",c.NA),y.CIRCULAR_ERROR=d("circular",0),y.INTERNAL_ERROR=d("internal",c.NA),y.throwErrorCode=function(a){if(a instanceof c)throw a;return a},y.throwInternal=function(b){throw a.error(b),y.INTERNAL_ERROR},y.getRecalcMode=function(a,b){return"always"===a||"always"===b?"always":"once"===a||"once"===b?"once":null},y.trunc=function(a){return 0>a?m(a):l(a)},y.add=function(a,b){return a+b},y.multiply=function(a,b){return a*b},y.divide=function(a,b){if(0===b)throw c.DIV0;return a/b},y.modulo=function(a,b){if(0===b)throw c.DIV0;var d=a%b;return 0!==d&&0>a*b?d+b:d},y.powerOOXML=function(a,b){if(0===a&&0===b)throw c.NUM;if(0===a&&0>b)throw c.DIV0;return p(a,b)},y.powerODF=function(a,b){if(0===a&&0>b)throw c.NUM;return p(a,b)},y.POWER={ooxml:y.powerOOXML,odf:y.powerODF},y.pow10=function(a){return p(10,a)},y.log10=function(a){return s(a)/v},y.arctan2=function(a,b){if(0===a&&0===b)throw c.DIV0;return Math.atan2(b,a)},y.sinh=Math.sinh||function(a){return(r(a)-r(-a))/2},y.cosh=Math.cosh||function(a){return(r(a)+r(-a))/2},y.tanh=Math.tanh||function(a){var b=r(a),c=r(-a);return(b-c)/(b+c)},y.asinh=Math.asinh||function(a){return s(a+q(a*a+1))},y.acosh=Math.acosh||function(a){return s(a+q(a*a-1))},y.atanh=Math.atanh||function(a){return s((1+a)/(1-a))/2},y.acoth=Math.acoth||function(a){return s((a+1)/(a-1))/2},y.sum=function(a){return a.reduce(y.add,0)},y.product=function(a){return a.reduce(y.multiply,1)},y.factorial=function(){var a=_.once(function(){for(var a=[],b=1;isFinite(b);)a.push(b),b*=a.length;return a});return function(b){var d=a()[l(b)];if(!d)throw c.NUM;return d}}(),y.binomial=function(){function a(a,b){for(var c=a-b+1,d=2;b>=d&&isFinite(c);)for(var e=0;10>e&&b>=d;d+=1,e+=1)c/=d,c*=a-b+d;return c}function b(b,f){if(b=l(b),f=l(f),0>b||0>f||f>b)throw c.NUM;if(0===f||f===b)return 1;if(1===f||f===b-1)return b;2*f>b&&(f=b-f);var g=0;if(e>=b){var h=b+","+f;return g=d[h],g?g:d[h]=a(b,f)}if(g=a(b,f),isFinite(g))return g;throw c.NUM}var d={},e=50;return b}(),y.erf=function(){function a(a){return a>=6?1:a>x?1-k(a):j(a)}function b(b){return b>0?a(b):0>b?-a(-b):0}return b}(),y.erfc=function(a){return a>x?k(a):1-y.erf(a)},y.slope=function(a){var b=(a.length-1)/2,c=y.sum(a)/a.length,d=a.reduce(function(a,d,e){return a+(e-b)*(d-c)},0),e=b*(b+1)*(2*b+1)/3;return d/e},y.combineParsedFormats=function(){var b=a.makeSet(["number","scientific","currency","percent","fraction"]),c=a.makeSet(["date","time","datetime"]);return function(a,d){if(!a||!d)return null;if(a.isStandard())return d;if(d.isStandard())return a;var e=a.category in b,f=d.category in b,g=!e&&a.category in c,h=!f&&d.category in c;return g&&f?a:e&&h?d:e&&f?a:null}}(),y.getScalarType=function(a,b){switch(typeof a){case"number":return y.ScalarType.NUMBER;case"string":return y.ScalarType.STRING;case"boolean":return y.ScalarType.BOOLEAN}return a instanceof c?y.ScalarType.ERROR:b?y.ScalarType.NULL_MAX:y.ScalarType.NULL},y.isZero=function(b){return o(b)<a.MIN_NUMBER},y.equalNumbers=function(a,b){return isFinite(a)&&isFinite(b)&&h(a,b)},y.equalStrings=function(b,c,d){var e=a.getBooleanOption(d,"withCase",!1);return i(b,c,e)},y.equalScalars=function(b,c,d){var f="convert"===a.getStringOption(d,"nullMode","convert");if(f&&(null===b&&(b=e(c)),null===c&&(c=e(b))),b===c)return!0;var g=y.getScalarType(b),h=y.getScalarType(c);if(g!==h)return!1;switch(g){case y.ScalarType.NUMBER:return y.equalNumbers(b,c);case y.ScalarType.STRING:return y.equalStrings(b,c,d)}return!1},y.compareNumbers=function(a,b){return isFinite(a)&&isFinite(b)?h(a,b)?0:b>a?-1:1:Number.NaN},y.compareStrings=function(b,c,d){if(a.getBooleanOption(d,"withCase",!1)){var e=Math.min(b.length,c.length);if(b.substr(0,e)===c.substr(0,e))return f(b.length,c.length);for(var g=0;e>g;g+=1){var h=b[g],i=c[g];if(h!==i){var j=h.toUpperCase(),k=i.toUpperCase();return k>j?-1:j>k?1:h!==j&&i===k?-1:1}}return a.error("FormulaUtils.compareStrings(): unexpected end of strings"),0}return b=b.toUpperCase(),c=c.toUpperCase(),c>b?-1:b>c?1:0},y.compareBooleans=function(a,b){return a-b},y.compareErrorCodes=function(a,b){return isFinite(a.num)&&isFinite(b.num)&&f(a.num,b.num)},y.compareScalars=function(b,c,d){var g=a.getStringOption(d,"nullMode","convert"),h="greater"===g;"convert"===g&&(null===b&&(b=e(c)),null===c&&(c=e(b)));var i=y.getScalarType(b,h),j=y.getScalarType(c,h);if(i!==j)return f(i,j);switch(i){case y.ScalarType.NUMBER:return y.compareNumbers(b,c);case y.ScalarType.STRING:return y.compareStrings(b,c,d);case y.ScalarType.BOOLEAN:return y.compareBooleans(b,c);case y.ScalarType.ERROR:return y.compareErrorCodes(b,c)}return 0},y.isValidMatrixSize=function(a,b){return a>0&&a<=y.MAX_MATRIX_ROW_COUNT&&b>0&&b<=y.MAX_MATRIX_COL_COUNT},y.ensureMatrixSize=function(a,b){if(!y.isValidMatrixSize(a,b))throw y.UNSUPPORTED_ERROR},y.implementFilterAggregation=function(a,b,c,d){return function(e,f,g){var h=this.convertToValueRange(e),i=[{range:h,criterion:f}],j=b?g?this.convertToValueRange(g):h.clone():null;return j&&(j.end[0]=Math.min(j.start[0]+h.cols()-1,this.docModel.getMaxCol()),j.end[1]=Math.min(j.start[1]+h.rows()-1,this.docModel.getMaxRow()),h.end[0]=h.start[0]+j.cols()-1,h.end[1]=h.start[1]+j.rows()-1),this.aggregateFiltered(i,j,a,b,c,d)}},y.implementParallelFilterAggregation=function(a,b,c,d){return function(){var e=b?this.convertToValueRange(arguments[0]):null,f=_.toArray(arguments);e&&(f=f.slice(1)),f.length%2&&y.throwInternal("invalid number of operands");var g=_.times(f.length/2,function(a){return{range:this.convertToValueRange(f[2*a]),criterion:f[2*a+1]}},this);return this.aggregateFiltered(g,e,a,b,c,d)}},y.valueToString=function(a){return"string"==typeof a?'"'+a.replace(/"/g,'""')+'"':a instanceof Date?a.toISOString():null===a?"null":a===!0?"TRUE":a===!1?"FALSE":a.toString()},y.logTokens=y.isLoggingActive()?function(a,b){y.log(a+": "+b.join(" "))}:$.noop,y});