define("io.ox/office/spreadsheet/model/formula/funcs/complexfuncs",["io.ox/office/spreadsheet/utils/errorcode","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/utils/complex"],function(a,b,c){"use strict";function d(b){return function(){var d=null,e=!1;if(this.iterateOperands(0,function(a){this.iterateScalars(a,function(a){var e=this.convertToComplex(a);d?(this.checkComplexUnits(d,e),d=b.call(this,d,e),d.unit=d.unit||e.unit):d=new c(e.real,e.imag,e.unit)},{emptyParam:!1,complexRef:!1}),a.isEmpty()||(e=!0)}),!e)throw a.NA;return _.isObject(d)?d:new c(0,0)}}var e=Math.sin,f=Math.cos,g=b.sinh,h=b.cosh;return{COMPLEX:{category:"complex",minParams:2,maxParams:3,type:"val",signature:"val:num val:num val:str",resolve:function(b,d,e){if(e||(e="i"),"i"!==e&&"j"!==e)throw a.VALUE;return new c(b,d,e)}},IMABS:{category:"complex",minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){return a.abs()}},IMAGINARY:{category:"complex",minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){return a.imag}},IMARGUMENT:{category:"complex",minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){return a.arg()}},IMCONJUGATE:{category:"complex",minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){return new c(a.real,-a.imag,a.unit)}},IMCOS:{category:"complex",minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){return new c(f(a.real)*h(a.imag),-e(a.real)*g(a.imag),a.unit)}},IMCOSH:{category:"complex",name:{ooxml:"_xlfn.IMCOSH"},minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){return new c(h(a.real)*f(a.imag),g(a.real)*e(a.imag),a.unit)}},IMCOT:{category:"complex",name:{ooxml:"_xlfn.IMCOT"},minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){var b=f(2*a.real)-h(2*a.imag);return new c(-e(2*a.real)/b,g(2*a.imag)/b,a.unit)}},IMCSC:{category:"complex",name:{ooxml:"_xlfn.IMCSC"},minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){var b=f(2*a.real)-h(2*a.imag);return new c(-2*e(a.real)*h(a.imag)/b,2*f(a.real)*g(a.imag)/b,a.unit)}},IMCSCH:{category:"complex",name:{ooxml:"_xlfn.IMCSCH"},minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){var b=h(2*a.real)-f(2*a.imag);return new c(2*g(a.real)*f(a.imag)/b,-2*h(a.real)*e(a.imag)/b,a.unit)}},IMDIV:{category:"complex",minParams:2,maxParams:2,type:"val",signature:"val:comp val:comp",resolve:function(a,b){this.checkComplexUnits(a,b);var d=b.real*b.real+b.imag*b.imag;return new c((a.real*b.real+a.imag*b.imag)/d,(a.imag*b.real-a.real*b.imag)/d,a.unit)}},IMEXP:{category:"complex",minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){return a.exp()}},IMLN:{category:"complex",minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){return a.log(1)}},IMLOG10:{category:"complex",minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){return a.log(Math.LN10)}},IMLOG2:{category:"complex",minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){return a.log(Math.LN2)}},IMPOWER:{category:"complex",minParams:2,maxParams:2,type:"val",signature:"val:comp val:num",resolve:function(a,b){return a.pow(b)}},IMPRODUCT:{category:"complex",minParams:1,type:"val",signature:"any",resolve:d(function(a,b){return new c(a.real*b.real-a.imag*b.imag,a.real*b.imag+a.imag*b.real)})},IMREAL:{category:"complex",minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){return a.real}},IMSEC:{category:"complex",name:{ooxml:"_xlfn.IMSEC"},minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){var b=f(2*a.real)+h(2*a.imag);return new c(2*f(a.real)*h(a.imag)/b,2*e(a.real)*g(a.imag)/b,a.unit)}},IMSECH:{category:"complex",name:{ooxml:"_xlfn.IMSECH"},minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){var b=h(2*a.real)+f(2*a.imag);return new c(2*h(a.real)*f(a.imag)/b,-2*g(a.real)*e(a.imag)/b,a.unit)}},IMSIN:{category:"complex",minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){return new c(e(a.real)*h(a.imag),f(a.real)*g(a.imag),a.unit)}},IMSINH:{category:"complex",name:{ooxml:"_xlfn.IMSINH"},minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){return new c(g(a.real)*f(a.imag),h(a.real)*e(a.imag),a.unit)}},IMSQRT:{category:"complex",minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){return a.pow(.5)}},IMSUB:{category:"complex",minParams:2,maxParams:2,type:"val",signature:"val:comp val:comp",resolve:function(a,b){return this.checkComplexUnits(a,b),new c(a.real-b.real,a.imag-b.imag,a.unit)}},IMSUM:{category:"complex",minParams:1,type:"val",signature:"any",resolve:d(function(a,b){return new c(a.real+b.real,a.imag+b.imag)})},IMTAN:{category:"complex",name:{ooxml:"_xlfn.IMTAN"},minParams:1,maxParams:1,type:"val",signature:"val:comp",resolve:function(a){var b=f(2*a.real)+h(2*a.imag);return new c(e(2*a.real)/b,g(2*a.imag)/b,a.unit)}}}});