define("io.ox/office/spreadsheet/model/formula/parser/expressionparser",["io.ox/office/tk/utils","io.ox/office/tk/locale/parser","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/utils/matrix","io.ox/office/spreadsheet/model/formula/utils/sheetref","io.ox/office/spreadsheet/model/formula/utils/cellref","io.ox/office/spreadsheet/model/formula/parser/tokens"],function(a,b,c,d,e,f,g,h){"use strict";function i(a,b){this.token=a,this.index=-1,this.text=b,this.start=0,this.end=0}var j=c.Address;i.prototype.toString=function(){return this.token.toString()};var k=_.makeExtendable(function(a,b){this.docModel=a,this.MAXCOL=a.getMaxCol(),this.MAXROW=a.getMaxRow(),this.grammar=b,this.RE=b.RE});k.prototype._initOptions=function(b){this.refAddress=a.getOption(b,"refAddress",null),this.refSheet=a.getIntegerOption(b,"refSheet",-1),this.refSheetModel=this.docModel.getSheetModel(this.refSheet),this.autoCorrect=a.getBooleanOption(b,"autoCorrect",!1),this.extendSheet=a.getBooleanOption(b,"extendSheet",!1),this.unqualifiedTables=a.getBooleanOption(b,"unqualifiedTables",!1)},k.prototype._parseNextToken=function(a){var c=this.RE,d=null,e=null;return(d=c.STRING_LIT.exec(a))?this.createLiteralToken(d[0].slice(1,d[0].length-1).replace(/""/g,'"'),d[0]):(d=c.BOOLEAN_LIT.exec(a))?this.createLiteralToken(this.grammar.getBooleanValue(d[0]),d[0]):(d=c.ERROR_LIT.exec(a))?this.createLiteralToken(this.grammar.getErrorCode(d[0]),d[0]):(d=c.FRACTION_LIT.exec(a))?this.createLiteralToken(parseInt(d[1],10)+parseInt(d[2],10)/parseInt(d[3],10),d[0]):(d=c.WHITESPACE.exec(a))?this.createFixedToken("ws",d[0]):(d=c.SEPARATOR.exec(a))?this.createToken(new h.SeparatorToken,d[0]):(d=c.OPERATOR.exec(a))?this.createToken(new h.OperatorToken(this.grammar.getOperatorKey(d[0])),d[0]):(d=c.OPEN.exec(a))?this.createToken(new h.ParenthesisToken(!0),d[0]):(d=c.CLOSE.exec(a))?this.createToken(new h.ParenthesisToken(!1),d[0]):(d=c.MATRIX_OPEN.exec(a))?this._parseMatrixLit(a):(e=this.parseNextRefToken(a))?e:(d=b.parseLeadingNumber(a,{dec:this.grammar.DEC}))?this.createLiteralToken(d.number,d.text):(e=this.parseNextNameToken(a))?e:void 0},k.prototype._parseMatrixLit=function(a){function c(){return j.every(function(a,b){return 0===b||a.length===j[b-1].length})}for(var d=a,f="start",g=this.RE,i=null,j=[],k=null;"end"!==f;){switch(f){case"start":(i=g.MATRIX_OPEN.exec(a))&&(j.push(k=[]),f="open");break;case"open":case"sep":(i=g.WHITESPACE.exec(a))||((i=g.FRACTION_LIT.exec(a))?(k.push(parseInt(i[1],10)+parseInt(i[2],10)/parseInt(i[3],10)),f="lit"):(i=b.parseLeadingNumber(a,{dec:this.grammar.DEC,sign:!0}))?(k.push(i.number),i=[i.text],f="lit"):(i=g.STRING_LIT.exec(a))?(k.push(i[0].slice(1,i[0].length-1).replace(/""/g,'"')),f="lit"):(i=g.BOOLEAN_LIT.exec(a))?(k.push(this.grammar.getBooleanValue(i[0])),f="lit"):(i=g.ERROR_LIT.exec(a))&&(k.push(this.grammar.getErrorCode(i[0])),f="lit"));break;case"lit":0===a.length?(i=this.autoCorrect&&c()?[""]:null,f="end"):(i=g.WHITESPACE.exec(a))||((i=g.MATRIX_ROW_SEPARATOR.exec(a))?(j.push(k=[]),f="sep"):(i=g.MATRIX_COL_SEPARATOR.exec(a))?f="sep":(i=g.MATRIX_CLOSE.exec(a))&&(c()||(i=null),f="end"))}if(!i)return null;a=a.substr(i[0].length)}var l=d.substr(0,d.length-a.length);return this.createToken(new h.MatrixToken(new e(j)),l)},k.prototype.createToken=function(a,b){return new i(a,b)},k.prototype.createFixedToken=function(a,b){return this.createToken(new h.FixedToken(a,b),b)},k.prototype.createLiteralToken=function(a,b){return this.createToken(new h.LiteralToken(a),b)},k.prototype.createReferenceToken=function(a,b,c){return!a&&this.extendSheet&&this.refSheetModel&&(a={r1:new f(this.refSheet,!0),r2:null}),this.createToken(new h.ReferenceToken(this.docModel,b?b.r1:null,b?b.r2:null,a?a.r1:null,a?a.r2:null),c)},k.prototype.createNameToken=function(a,b,c){return!a&&this.extendSheet&&this.refSheetModel&&this.refSheetModel.getNameCollection().hasName(b)&&(a=new f(this.refSheet,!0)),this.createToken(new h.NameToken(this.docModel,b,a),c)},k.prototype.createFunctionToken=function(a,b,c){var d=a?null:this.grammar.getFunctionKey(b);return this.createToken(d?new h.FunctionToken(d):new h.MacroToken(this.docModel,b,a),c)},k.prototype.createSheetRef=function(a,b,c,d){return d||(d=!!a[b],b+=1),f.create(this.docModel,a[b],a[b+1],c?a[b+2]:null,d)},k.prototype.createSheetRefData=function(a,b,c,d){return{r1:this.createSheetRef(a,b,c,d),r2:null}},k.prototype.createA1CellRef=function(a,b){var c=j.parseCol(a[b+1]),d=j.parseRow(a[b+3]);return c>=0&&c<=this.MAXCOL&&d>=0&&d<=this.MAXROW?new g(c,d,!!a[b],!!a[b+2]):null},k.prototype.createA1ColRef=function(a,b,c){var d=j.parseCol(a[b+1]);return d>=0&&d<=this.MAXCOL?new g(d,c,!!a[b],!0):null},k.prototype.createA1RowRef=function(a,b,c){var d=j.parseRow(a[b+1]);return d>=0&&d<=this.MAXROW?new g(c,d,!0,!!a[b]):null},k.prototype.createA1CellData=function(a,b){var c=this.createA1CellRef(a,b);return c?{r1:c,r2:null}:null},k.prototype.createA1CellRangeData=function(a,b,c){var d=this.createA1CellRef(a,b),e=d?this.createA1CellRef(a,c):null;return e?{r1:d,r2:e}:null},k.prototype.createA1ColRangeData=function(a,b,c){var d=this.createA1ColRef(a,b,0),e=d?this.createA1ColRef(a,c,this.MAXROW):null;return e?{r1:d,r2:e}:null},k.prototype.createA1RowRangeData=function(a,b,c){var d=this.createA1RowRef(a,b,0),e=d?this.createA1RowRef(a,c,this.MAXCOL):null;return e?{r1:d,r2:e}:null},k.prototype.parseNextRefToken=function(){return a.error("ExpressionParserBase.parseNextRefToken(): missing implementation"),null},k.prototype.parseNextNameToken=function(){return a.error("ExpressionParserBase.parseNextNameToken(): missing implementation"),null},k.prototype.parseFormula=function(b,c){this._initOptions(c);for(var e=[];b.length>0;){var f=this._parseNextToken(b)||this.createFixedToken("bad",b);e.push(f),b=b.substr(f.text.length)}d.logTokens("tokenize",e);var g=" "===this.grammar.getOperatorName("isect");return a.iterateArray(e,function(a,b){var c=a.token,d=e[b-1],f=e[b+1];if(c.isType("op")&&"sub"===c.getValue()&&f&&f.token.isType("lit")){var i=f.token.getValue();if("number"==typeof i&&i>0){var j=d&&d.token.isType("ws")?e[b-2]:d;(!j||j.token.matchesType(/^(op|sep|open)$/))&&(a.token=new h.LiteralToken(-i),a.text+=f.text,e.splice(b+1,1))}}if(g&&c.isType("ws")){var k=k=a.text.indexOf(" ");if(k>=0&&d&&d.token.matchesType(/^(ref|name|close)$/)&&f&&f.token.matchesType(/^(ref|name|open|func)$/)){if(k+1<a.text.length){var l=a.text.slice(k+1);e.splice(b+1,0,this.createFixedToken("ws",l))}e.splice(b+1,0,this.createToken(new h.OperatorToken("isect")," ")),k>0?(c.setValue(a.text.slice(0,k)),a.text=c.getValue()):e.splice(b,1)}}},{reverse:!0,context:this}),d.logTokens("postprocess",e),e.forEach(function(a,b){a.index=b,a.start=0===b?0:e[b-1].end,a.end=a.start+a.text.length}),e},k.prototype.destroy=function(){this.docModel=this.grammar=this.RE=this.refSheetModel=null};var l=k.extend({constructor:function(a,b){k.call(this,a,b)}});l.prototype._parseTableRef=function(a,b){function c(){r[m.getTableRegionKey(p[1])]=!0,o="ref"}function d(a,b){"col1Name"in q?(p=null,o="end"):(q.col1Name=m.decodeTableColumn(a),q.col2Name=b?m.decodeTableColumn(b):null,o="ref")}function e(){d(p[1],p[2])}function f(a){a&&p[1]&&(q.openWs=!0),d(p[2]||p[3],p[4]||p[5])}function g(){p[1]&&(q.closeWs=!0),n||0!==p[2].length||(p=null),o="end"}var i=this.RE,j=a;b&&(a=a.substr(b.text.length));var k=i.TABLE_OPEN.test(a),l=b?b.token.resolveTableModel():null;if(b&&k&&!l)return null;if(b&&!k&&l)return this.createToken(new h.TableToken(this.docModel,b.token.getValue()),b.text);if(!k)return b;if(!b&&this.grammar.UI&&this.unqualifiedTables&&this.refAddress&&this.refSheetModel&&(l=this.refSheetModel.getTableCollection().findTable(this.refAddress)),!l)return null;for(var m=this.grammar,n=this.autoCorrect,o="start",p=null,q={},r={};"end"!==o;){switch(o){case"start":(p=i.TABLE_OPEN.exec(a))&&(p[1]&&(q.openWs=!0),o="open");break;case"open":(p=i.TABLE_CLOSE.exec(a))?g():(p=i.TABLE_SINGLE_REGION_NAME.exec(a))?c():(p=i.TABLE_SINGLE_COLUMN_NAME.exec(a))?e():(p=i.TABLE_REGION_REF.exec(a))?c():!this.grammar.UI&&(p=i.TABLE_COLUMN_RANGE_REF.exec(a))?e():!this.grammar.UI&&(p=i.TABLE_COLUMN_REF.exec(a))?e():this.grammar.UI&&(p=i.TABLE_MIXED_COLUMN_RANGE_REF.exec(a))?f(!0):this.grammar.UI&&(p=i.TABLE_MIXED_COLUMN_REF.exec(a))?f(!0):this.grammar.UI&&(p=i.TABLE_THISROW_REF.exec(a))&&(r.ROW=!0,o="row");break;case"ref":(p=i.TABLE_CLOSE.exec(a))?g():(p=i.TABLE_SEPARATOR.exec(a))&&(p[2]&&(q.sepWs=!0),o="sep");break;case"sep":(p=i.TABLE_REGION_REF.exec(a))?c():!this.grammar.UI&&(p=i.TABLE_COLUMN_RANGE_REF.exec(a))?e():!this.grammar.UI&&(p=i.TABLE_COLUMN_REF.exec(a))?e():this.grammar.UI&&(p=i.TABLE_MIXED_COLUMN_RANGE_REF.exec(a))?f():this.grammar.UI&&(p=i.TABLE_MIXED_COLUMN_REF.exec(a))&&f();break;case"row":(p=i.TABLE_CLOSE.exec(a))?(g(),q.closeWs&&(p=null)):(p=i.WHITESPACE.exec(a))||((p=i.TABLE_MIXED_COLUMN_RANGE_REF.exec(a))?f():(p=i.TABLE_MIXED_COLUMN_REF.exec(a))&&f())}if(!p)return null;a=a.substr(p[0].length)}switch(r=_.keys(r),r.length){case 0:break;case 1:q.regionKey=r[0];break;case 2:if(r=r.join(","),"HEADERS,DATA"===r||"DATA,HEADERS"===r)q.regionKey="HEADERS,DATA";else{if("DATA,TOTALS"!==r&&"TOTALS,DATA"!==r)return null;q.regionKey="DATA,TOTALS"}break;default:return null}var s=j.substr(0,j.length-a.length);return this.createToken(new h.TableToken(this.docModel,l.getName(),q),s)},l.prototype.createSheetRangeData=function(a,b){var c=f.create(this.docModel,a[b],a[b+2],null,!0),d=f.create(this.docModel,a[b+1],a[b+3],null,!0);return{r1:c,r2:d}},l.prototype.parseNextRefToken=function(a){var b=this.RE,c=null,d=null;return(c=b.RANGE_REF.exec(a))&&(d=this.createA1CellRangeData(c,1,5))?this.createReferenceToken(null,d,c[0]):(c=b.RANGE_ABS3D_REF.exec(a))&&(d=this.createA1CellRangeData(c,4,8))?this.createReferenceToken(this.createSheetRefData(c,1,!0,!0),d,c[0]):(c=b.RANGE_ABSCUBE_REF.exec(a))&&(d=this.createA1CellRangeData(c,5,9))?this.createReferenceToken(this.createSheetRangeData(c,1),d,c[0]):(c=b.CELL_REF.exec(a))&&(d=this.createA1CellData(c,1))?this.createReferenceToken(null,d,c[0]):(c=b.CELL_ABS3D_REF.exec(a))&&(d=this.createA1CellData(c,4))?this.createReferenceToken(this.createSheetRefData(c,1,!0,!0),d,c[0]):(c=b.CELL_ABSCUBE_REF.exec(a))&&(d=this.createA1CellData(c,5))?this.createReferenceToken(this.createSheetRangeData(c,1),d,c[0]):(c=b.COLS_REF.exec(a))&&(d=this.createA1ColRangeData(c,1,3))?this.createReferenceToken(null,d,c[0]):(c=b.COLS_ABS3D_REF.exec(a))&&(d=this.createA1ColRangeData(c,4,6))?this.createReferenceToken(this.createSheetRefData(c,1,!0,!0),d,c[0]):(c=b.COLS_ABSCUBE_REF.exec(a))&&(d=this.createA1ColRangeData(c,5,7))?this.createReferenceToken(this.createSheetRangeData(c,1),d,c[0]):(c=b.ROWS_REF.exec(a))&&(d=this.createA1RowRangeData(c,1,3))?this.createReferenceToken(null,d,c[0]):(c=b.ROWS_ABS3D_REF.exec(a))&&(d=this.createA1RowRangeData(c,4,6))?this.createReferenceToken(this.createSheetRefData(c,1,!0,!0),d,c[0]):(c=b.ROWS_ABSCUBE_REF.exec(a))&&(d=this.createA1RowRangeData(c,5,7))?this.createReferenceToken(this.createSheetRangeData(c,1),d,c[0]):(c=b.ERROR_ABS3D_REF.exec(a))?this.createReferenceToken(this.createSheetRefData(c,1,!0,!0),null,c[0]):(c=b.ERROR_ABSCUBE_REF.exec(a))?this.createReferenceToken(this.createSheetRangeData(c,1),null,c[0]):void 0},l.prototype.parseNextNameToken=function(a){var b=this.RE,c=null;return(c=b.FUNCTION_REF.exec(a))?this.createFunctionToken(null,c[1],c[0]):(c=b.FUNCTION_ABS3D_REF.exec(a))?this.createFunctionToken(this.createSheetRef(c,1,!0,!0),c[4],c[0]):(c=b.NAME_ABS3D_REF.exec(a))?this._parseTableRef(a,this.createNameToken(this.createSheetRef(c,1,!0,!0),c[4],c[0])):(c=b.NAME_REF.exec(a))?this._parseTableRef(a,this.createNameToken(null,c[1],c[0])):this.grammar.UI&&(c=b.TABLE_OPEN.exec(a))?this._parseTableRef(a,null):void 0};var m=k.extend({constructor:function(a,b){k.call(this,a,b)}});m.prototype.createSheetRangeData=function(a,b){var c=f.create(this.docModel,a[b+1],a[b+2],null,!!a[b]),d=f.create(this.docModel,a[b+4],a[b+5],null,!!a[b+3]);return{r1:c,r2:d}},m.prototype.parseNextRefToken=function(a){var b=this.RE,c=null,d=null;return(c=b.RANGE_REF.exec(a))&&(d=this.createA1CellRangeData(c,1,5))?this.createReferenceToken(null,d,c[0]):(c=b.RANGE_REL3D_REF.exec(a))&&(d=this.createA1CellRangeData(c,5,9))?this.createReferenceToken(this.createSheetRefData(c,1,!0),d,c[0]):(c=b.RANGE_RELCUBE_REF.exec(a))&&(d=this.createA1CellRangeData(c,7,11))?this.createReferenceToken(this.createSheetRangeData(c,1),d,c[0]):(c=b.CELL_REF.exec(a))&&(d=this.createA1CellData(c,1))?this.createReferenceToken(null,d,c[0]):(c=b.CELL_REL3D_REF.exec(a))&&(d=this.createA1CellData(c,5))?this.createReferenceToken(this.createSheetRefData(c,1,!0),d,c[0]):(c=b.CELL_RELCUBE_REF.exec(a))&&(d=this.createA1CellData(c,7))?this.createReferenceToken(this.createSheetRangeData(c,1),d,c[0]):(c=b.COLS_REF.exec(a))&&(d=this.createA1ColRangeData(c,1,3))?this.createReferenceToken(null,d,c[0]):(c=b.COLS_REL3D_REF.exec(a))&&(d=this.createA1ColRangeData(c,5,7))?this.createReferenceToken(this.createSheetRefData(c,1,!0),d,c[0]):(c=b.COLS_RELCUBE_REF.exec(a))&&(d=this.createA1ColRangeData(c,7,9))?this.createReferenceToken(this.createSheetRangeData(c,1),d,c[0]):(c=b.ROWS_REF.exec(a))&&(d=this.createA1RowRangeData(c,1,3))?this.createReferenceToken(null,d,c[0]):(c=b.ROWS_REL3D_REF.exec(a))&&(d=this.createA1RowRangeData(c,5,7))?this.createReferenceToken(this.createSheetRefData(c,1,!0),d,c[0]):(c=b.ROWS_RELCUBE_REF.exec(a))&&(d=this.createA1RowRangeData(c,7,9))?this.createReferenceToken(this.createSheetRangeData(c,1),d,c[0]):(c=b.ERROR_REL3D_REF.exec(a))?this.createReferenceToken(this.createSheetRefData(c,1,!0),null,c[0]):(c=b.ERROR_RELCUBE_REF.exec(a))?this.createReferenceToken(this.createSheetRangeData(c,1),null,c[0]):void 0},m.prototype.parseNextNameToken=function(a){var b=this.RE,c=null;return(c=b.FUNCTION_REF.exec(a))?this.createFunctionToken(null,c[1],c[0]):(c=b.NAME_REF.exec(a))?this.createNameToken(null,c[1],c[0]):void 0};var n=k.extend({constructor:function(a,b){k.call(this,a,b)}});n.prototype.createSheetRangeData=function(a,b,c,d){return{r1:this.createSheetRef(a,b,d),r2:this.createSheetRef(a,c,d)}},n.prototype.parseNextRefToken=function(a){var b=this.RE,c=null;return(c=b.OF_CELL_REF.exec(a))?this.createReferenceToken(null,this.createA1CellData(c,1),c[0]):(c=b.OF_CELL_3D_REF.exec(a))?this.createReferenceToken(this.createSheetRefData(c,1,!0),this.createA1CellData(c,5),c[0]):(c=b.OF_RANGE_REF.exec(a))?this.createReferenceToken(null,this.createA1CellRangeData(c,1,5),c[0]):(c=b.OF_RANGE_3D_REF.exec(a))?this.createReferenceToken(this.createSheetRefData(c,1,!0),this.createA1CellRangeData(c,5,9),c[0]):(c=b.OF_RANGE_CUBE_REF.exec(a))?this.createReferenceToken(this.createSheetRangeData(c,1,9,!0),this.createA1CellRangeData(c,5,13),c[0]):void 0},n.prototype.parseNextNameToken=function(a){var b=this.RE,c=null;return(c=b.OF_FUNCTION_REF.exec(a))?this.createFunctionToken(null,c[1],c[0]):(c=b.NAME_REF.exec(a))?this.createNameToken(null,c[1],c[0]):void 0};var o={};return o.create=function(b,c){var d=b.getFormulaGrammar(c);switch(d.REF_SYNTAX){case"ooxml":return new l(b,d);case"odfui":return new m(b,d);case"of":return new n(b,d)}a.error('ExpressionParser.create(): invalid reference syntax: "'+d.REF_SYNTAX+'"')},o});