define("io.ox/office/spreadsheet/model/formula/parser/rangelistparser",["io.ox/office/tk/utils","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/utils/sheetref"],function(a,b,c){"use strict";var d=b.Address,e=b.Range,f=b.RangeArray,g=_.makeExtendable(function(a,b){this.docModel=a,this.MAXCOL=a.getMaxCol(),this.MAXROW=a.getMaxRow(),this.grammar=b,this.RE=b.RANGE_LIST_RE});g.prototype._initOptions=function(b){this.refSheet=a.getIntegerOption(b,"refSheet",-1),this.refSheetModel=this.docModel.getSheetModel(this.refSheet),this.extSep=a.getBooleanOption(b,"extSep",!1),this.skipSheets=a.getBooleanOption(b,"skipSheets",!1)},g.prototype._parseSeparator=function(a){var b=this.RE,c=null;return(c=b.SEP_WS.exec(a))?{sep:" ",text:c[0]}:this.extSep&&(c=b.SEP_OTHER.exec(a))?{sep:c[0],text:c[0]}:null},g.prototype.getCol=function(a,b){var c=d.parseCol(a[b]);return c<=this.MAXCOL?c:-1},g.prototype.getRow=function(a,b){var c=d.parseRow(a[b]);return c<=this.MAXROW?c:-1},g.prototype.getAddress=function(a,b){var c=this.getCol(a,b),e=this.getRow(a,b+1);return c>=0&&e>=0?new d(c,e):null},g.prototype.getRange=function(a,b,c){var d=this.getAddress(a,b),f="number"==typeof c?this.getAddress(a,c):d;return d&&f?e.createFromAddresses(d,f):null},g.prototype.getColRange=function(a,b){var c=this.getCol(a,b),d=this.getCol(a,b+1);return c>=0&&d>=0?e.create(c,0,d,this.MAXROW):null},g.prototype.getRowRange=function(a,b){var c=this.getRow(a,b),d=this.getRow(a,b+1);return c>=0&&d>=0?e.create(0,c,this.MAXCOL,d):null},g.prototype.createRangeDesc=function(a,b,c){if(!b)return null;if(a){if(a.r1.sheet!==this.refSheet)return null;if(a.r2&&a.r2.sheet!==this.refSheet)return null}return{range:b,text:c}},g.prototype.implParseRange=function(){return a.error("RangeListParserBase.implParseRange(): missing implementation"),null},g.prototype.implFormatRange=function(){return a.error("RangeListParserBase.implFormatRange(): missing implementation"),null},g.prototype.parseRangeList=function(a,b){this._initOptions(b);for(var c="start",d=new f,e=null;"end"!==c;)switch(c){case"start":c="range";break;case"range":var g=this.implParseRange(a);if(!g)return null;d.push(g.range),a=a.substr(g.text.length),c="sep";break;case"sep":if(0===a.length){c="end";break}var h=this._parseSeparator(a);if(!h||null!==e&&e!==h.sep)return null;e=h.sep,a=a.substr(h.text.length),c="range"}return d},g.prototype.formatRangeList=function(b,c){var d=a.getStringOption(c,"sep"," "),e=a.getStringOption(c,"sheetName",null);return f.get(b).map(function(a){return this.implFormatRange(a,e)},this).join(d)},g.prototype.destroy=function(){this.docModel=this.grammar=this.RE=this.refSheetModel=null};var h=g.extend({constructor:function(a,b){g.call(this,a,b)}});h.prototype.implParseRange=function(a){var b=this.RE,c=null;if(this.skipSheets){if(c=b.RANGE_3D.exec(a))return this.createRangeDesc(null,this.getRange(c,3,5),c[0]);if(c=b.RANGE_CUBE.exec(a))return this.createRangeDesc(null,this.getRange(c,5,7),c[0]);if(c=b.CELL_3D.exec(a))return this.createRangeDesc(null,this.getRange(c,3),c[0]);if(c=b.CELL_CUBE.exec(a))return this.createRangeDesc(null,this.getRange(c,5),c[0]);if(c=b.COLS_3D.exec(a))return this.createRangeDesc(null,this.getColRange(c,3),c[0]);if(c=b.COLS_CUBE.exec(a))return this.createRangeDesc(null,this.getColRange(c,5),c[0]);if(c=b.ROWS_3D.exec(a))return this.createRangeDesc(null,this.getRowRange(c,3),c[0]);if(c=b.ROWS_CUBE.exec(a))return this.createRangeDesc(null,this.getRowRange(c,5),c[0])}return(c=b.RANGE.exec(a))?this.createRangeDesc(null,this.getRange(c,1,3),c[0]):(c=b.CELL.exec(a))?this.createRangeDesc(null,this.getRange(c,1),c[0]):(c=b.COLS.exec(a))?this.createRangeDesc(null,this.getColRange(c,1),c[0]):(c=b.ROWS.exec(a))?this.createRangeDesc(null,this.getRowRange(c,1),c[0]):void 0},h.prototype.implFormatRange=function(a,b){var e=null,f=null;a.single()?e=a.start.toString():this.docModel.isRowRange(a)?(e=d.stringifyRow(a.start[1]),f=d.stringifyRow(a.end[1])):this.docModel.isColRange(a)?(e=d.stringifyCol(a.start[0]),f=d.stringifyCol(a.end[0])):(e=a.start.toString(),f=a.end.toString());var g=b?new c(b,!1):null;return this.grammar.formatGenericRange(this.docModel,g,null,e,f)};var i=g.extend({constructor:function(a,b){g.call(this,a,b)}});i.prototype.implParseRange=function(a){var b=this.RE,c=null;if(this.skipSheets){if(c=b.OF_RANGE_CUBE.exec(a))return this.createRangeDesc(null,this.getRange(c,3,7),c[0]);if(c=b.OF_RANGE_3D.exec(a))return this.createRangeDesc(null,this.getRange(c,3,5),c[0]);if(c=b.OF_CELL_3D.exec(a))return this.createRangeDesc(null,this.getRange(c,3),c[0])}return(c=b.RANGE.exec(a))?this.createRangeDesc(null,this.getRange(c,1,3),c[0]):(c=b.CELL.exec(a))?this.createRangeDesc(null,this.getRange(c,1),c[0]):void 0},i.prototype.implFormatRange=function(a,b){var d=a.start.toString(),e=a.single()?null:a.end.toString(),f=b?new c(b,!1):null,g=b&&e?f:null;return this.grammar.formatGenericRange(this.docModel,f,g,d,e)};var j={};return j.create=function(b,c){var d=b.getFormulaGrammar(c);switch(d.REF_SYNTAX){case"ooxml":case"odfui":return new h(b,d);case"of":return new i(b,d)}a.error('RangeListParser.create(): invalid reference syntax: "'+d.REF_SYNTAX+'"')},j});