define("io.ox/office/spreadsheet/model/formula/parser/tokens",["io.ox/office/tk/utils","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/utils/sheetref","io.ox/office/spreadsheet/model/formula/utils/cellref"],function(a,b,c,d,e){"use strict";function f(a){return _.isObject(a)&&!a.valid()}var g=b.ErrorCode,h=b.Interval,i=b.Address,j=b.Range,k=b.Range3D,l=b.IntervalArray,m=b.Range3DArray,n=_.makeExtendable(function(a){this._type=a});n.prototype.getType=function(){return this._type},n.prototype.isType=function(a){return a===this._type},n.prototype.matchesType=function(a){return a.test(this._type)},n.prototype.getText=function(){return a.error("BaseToken.getText(): missing implementation"),""},n.prototype.debugText=function(){return a.error("BaseToken.debugText(): missing implementation"),""},n.prototype.toString=function(){var a=this.debugText();return this._type+(a?"["+a+"]":"")},n.prototype.resolveDeletedSheet=function(){return null},n.prototype.resolveRenamedSheet=function(){return null},n.prototype.resolveRelabeledName=function(){return null},n.prototype.resolveMovedCells=function(){return null};var o=n.extend({constructor:function(a,b){n.call(this,a),this._text=b}});o.prototype.getValue=function(){return this._text},o.prototype.setValue=function(a){return this._text===a?!1:(this._text=a,!0)},o.prototype.appendValue=function(a){return 0===a.length?!1:(this._text+=a,!0)},o.prototype.getText=function(){return this._text},o.prototype.debugText=function(){return this._text};var p=n.extend({constructor:function(a){n.call(this,"op"),this._value=a}});p.prototype.getValue=function(){return this._value},p.prototype.getText=function(a){return a.getOperatorName(this._value)||"?"},p.prototype.debugText=function(){return this._value};var q=n.extend({constructor:function(){n.call(this,"sep")}});q.prototype.getText=function(a){return a.SEP},q.prototype.debugText=_.constant("");var r=o.extend({constructor:function(a){o.call(this,a?"open":"close",a?"(":")")}});r.prototype.debugText=_.constant("");var s=n.extend({constructor:function(a){n.call(this,"lit"),this._value=a}});s.prototype.getValue=function(){return this._value},s.prototype.setValue=function(a){return this._value===a?!1:(this._value=a,!0)},s.prototype.getText=function(a){return a.formatScalar(this._value)},s.prototype.debugText=function(){return c.valueToString(this._value)};var t=n.extend({constructor:function(a){n.call(this,"mat"),this._matrix=a}});t.prototype.getMatrix=function(){return this._matrix},t.prototype.getText=function(a){var b=a.MAT_OPEN;return this._matrix.forEach(function(c,d,e){e>0?b+=a.MAT_COL:d>0&&(b+=a.MAT_ROW),b+=a.formatScalar(c)}),b+a.MAT_CLOSE},t.prototype.debugText=function(){return this._matrix.toString()};var u=n.extend({constructor:function(a){n.call(this,"func"),this._value=a}});u.prototype.getValue=function(){return this._value},u.prototype.getText=function(a){return a.getFunctionName(this._value)||this._value.toUpperCase()},u.prototype.debugText=function(){return this._value};var v=n.extend({constructor:function(a,b,c,d){if(n.call(this,a),this._docModel=b,this._sheet1Ref=c,this._sheet2Ref=d,c&&c.valid()&&d&&d.valid()&&d.sheet<c.sheet){var e=d.abs;d.abs=c.abs,c.abs=e;var f=d.sheet;d.sheet=c.sheet,c.sheet=f}}});v.prototype._resolveSheetRefs=function(b){return{s1:a.getOption(b,"sheet1Ref",this._sheet1Ref),s2:a.getOption(b,"sheet2Ref",this._sheet2Ref)}},v.prototype._resolveSheetInterval=function(b){var c=this._sheet1Ref?this._sheet1Ref.sheet:a.getIntegerOption(b,"refSheet",null),d=this._sheet2Ref?this._sheet2Ref.sheet:c;return _.isNumber(c)&&c>=0&&_.isNumber(d)&&d>=0?h.create(c,d):null},v.prototype.hasSheetRef=function(){return _.isObject(this._sheet1Ref)},v.prototype.hasSheetError=function(){return f(this._sheet1Ref)||f(this._sheet2Ref)},v.prototype.refreshSheets=function(){var a=_.isObject(this._sheet1Ref)&&this._sheet1Ref.refresh(this._docModel),b=_.isObject(this._sheet2Ref)&&this._sheet2Ref.refresh(this._docModel);return a||b},v.prototype.transformSheet=function(a,b){var c=_.isObject(this._sheet1Ref)&&this._sheet1Ref.transform(a,b),d=_.isObject(this._sheet2Ref)&&this._sheet2Ref.transform(a,b);return c||d},v.prototype.debugSheetPrefix=function(){if(!this._sheet1Ref)return"";var a=this._sheet1Ref.toString();return this._sheet2Ref&&!this._sheet1Ref.equals(this._sheet2Ref)&&(a+=":"+this._sheet2Ref.toString()),a+"!"},v.prototype.resolveDeletedSheet=function(a,b,c){var e=this._sheet1Ref?this._resolveSheetInterval({refSheet:c}):null;return e?e.single()?b===e.first?this.getText(a,{sheet1Ref:new d(-1,!0)}):null:b===e.first?this.getText(a,{sheet1Ref:new d(e.first+1,this._sheet1Ref.abs),sheet2Ref:new d(e.last,this._sheet2Ref.abs)}):b===e.last?this.getText(a,{sheet1Ref:new d(e.first,this._sheet1Ref.abs),sheet2Ref:new d(e.last-1,this._sheet2Ref.abs)}):null:null},v.prototype.resolveRenamedSheet=function(a,b,c){var e=this._sheet1Ref&&this._sheet1Ref.sheet===b?new d(c,this._sheet1Ref.abs):this._sheet1Ref,f=this._sheet2Ref&&this._sheet2Ref.sheet===b?new d(c,this._sheet2Ref.abs):this._sheet2Ref;return e!==this._sheet1Ref||f!==this._sheet2Ref?this.getText(a,{sheet1Ref:e,sheet2Ref:f}):null};var w=v.extend({constructor:function(a,b,c,d,e){if(v.call(this,"ref",a,d,e),this._cell1Ref=b,this._cell2Ref=c,b&&c&&c.col<b.col){var f=c.absCol;c.absCol=b.absCol,b.absCol=f;var g=c.col;c.col=b.col,b.col=g}if(this._cell1Ref&&this._cell2Ref&&this._cell2Ref.row<this._cell1Ref.row){var h=c.absRow;c.absRow=b.absRow,b.absRow=h;var i=c.row;c.row=b.row,b.row=i}}});w.prototype._isSingleRelative=function(a){return this._cell1Ref.isAbs(a)?!1:this._cell2Ref?!this._cell2Ref.isAbs(a)&&this._cell1Ref.getIndex(a)===this._cell2Ref.getIndex(a):!0},w.prototype._resolveCellRefs=function(b){var c=a.getOption(b,"refAddress",i.A1),d=a.getOption(b,"targetAddress",i.A1);if(c.equals(d))return{r1:this._cell1Ref,r2:this._cell2Ref};var e={r1:this._cell1Ref?this._cell1Ref.clone():null,r2:this._cell2Ref?this._cell2Ref.clone():null},f=a.getBooleanOption(b,"wrapReferences",!1);return e.r1&&!e.r1.relocate(this._docModel,c,d,f)&&(e.r1=null),e.r1&&e.r2&&!e.r2.relocate(this._docModel,c,d,f)&&(e.r1=e.r2=null),e},w.prototype.getRange3D=function(a){var b=this._resolveSheetInterval(a);if(!b)return null;var c=this._resolveCellRefs(a);if(!c.r1)return null;var d=c.r1.toAddress(),e=c.r2?c.r2.toAddress():null;return e?k.createFromAddresses(d,e,b.first,b.last):k.createFromAddress(d,b.first,b.last)},w.prototype.getExpandedRanges=function(b,c,d){function e(a,c,d,e){var f=a.getIndex(d);if(a.isAbs(d))return f;var g=(e?c.start:c.end).get(d);return f+g-b.get(d)}function f(a,b){var c=e(this._cell1Ref,a,b,!0);this._cell2Ref&&(c=Math.min(c,e(this._cell2Ref,a,b,!0)));var d=e(this._cell1Ref,a,b,!1);this._cell2Ref&&(d=Math.max(d,e(this._cell2Ref,a,b,!1)));var f=this._docModel.getMaxIndex(b);if(i){0>c?(c+=f+1,d+=f+1):c>f&&(c-=f+1,d-=f+1);var g=new l;return f>=d?g.push(new h(c,d)):this._isSingleRelative(b)?(g.push(new h(0,d-f-1)),g.push(new h(c,f))):g.push(new h(0,f)),g}return c=Math.max(c,0),d=Math.min(d,f),d>=c?new l(new h(c,d)):null}if(!this._cell1Ref)return null;var g=this._resolveSheetInterval(d);if(!g)return null;var i=a.getBooleanOption(d,"wrapReferences",!1);return m.map(c,function(a){var b=f.call(this,a,!0),c=b?f.call(this,a,!1):null;return c?m.createFromIntervals(b,c,g.first,g.last):null},this)},w.prototype.setRange=function(a){var b=!1;return this._cell1Ref||(this._cell1Ref=new e(0,0,!0,!0),b=!0),this._cell2Ref||a.single()||(this._cell2Ref=this._cell1Ref.clone(),b=!0),this._cell1Ref.col!==a.start[0]&&(this._cell1Ref.col=a.start[0],b=!0),this._cell1Ref.row!==a.start[1]&&(this._cell1Ref.row=a.start[1],b=!0),this._cell2Ref&&(this._cell2Ref.col!==a.end[0]&&(this._cell2Ref.col=a.end[0],b=!0),this._cell2Ref.row!==a.end[1]&&(this._cell2Ref.row=a.end[1],b=!0),this._cell1Ref.equals(this._cell2Ref)&&(this._cell2Ref=null,b=!0)),b},w.prototype.relocateRange=function(a,b,c){return!this._cell1Ref||a.equals(b)?!1:this._cell1Ref.relocate(this._docModel,a,b,c)?(this._cell2Ref&&!this._cell2Ref.relocate(this._docModel,a,b,c)&&(this._cell1Ref=this._cell2Ref=null),!0):(this._cell1Ref=this._cell2Ref=null,!0)},w.prototype.getText=function(a,b){var c=this._resolveSheetRefs(b),d=this._resolveCellRefs(b);return a.formatReference(this._docModel,c.s1,c.s2,d.r1,d.r2)},w.prototype.debugText=function(){var a=this.debugSheetPrefix();return a+=this._cell1Ref?this._cell1Ref:g.REF,a+=this._cell1Ref&&this._cell2Ref?":"+this._cell2Ref:""},w.prototype.resolveMovedCells=function(b,c,d,f){var g=this.getRange3D(f);if(!g||!g.isSheet(c))return null;var h=a.getBooleanOption(f,"freezeRelRefs",!1),i=g.toRange(),k=i.clone();if(d.every(function(a){if(h){var b=!this._cell1Ref.isAbs(a.columns),c=!this._cell2Ref||!this._cell2Ref.isAbs(a.columns);if(b&&c)return k;if(b){var d=a.transformAddress(k.end);return k=d?j.createFromAddresses(k.start,d):null}if(c){var e=a.transformAddress(k.start);return k=e?j.createFromAddresses(e,k.end):null}}return k=a.transformRange(k)},this),k&&k.equals(i))return null;var l=k&&e.create(k.start,this._cell1Ref.absCol,this._cell1Ref.absRow),m=k&&this._cell2Ref&&e.create(k.end,this._cell2Ref.absCol,this._cell2Ref.absRow);return{text:b.formatReference(this._docModel,this._sheet1Ref,this._sheet2Ref,l,m),refError:!l&&!m}};var x=v.extend({constructor:function(a,b,c){v.call(this,"name",a,c,null),this._value=b}});x.prototype._getNameModelFromSheet=function(a,b){var c=_.isNumber(a)?this._docModel.getSheetModel(a):null;return c?c.getNameCollection().getName(b):null},x.prototype._resolveNameModel=function(a,b){return this._sheet1Ref?this._getNameModelFromSheet(this._sheet1Ref.sheet,a):this._getNameModelFromSheet(b,a)||this._docModel.getNameCollection().getName(a)},x.prototype._resolveTableModel=function(a){if(this._sheet1Ref){var b=this._sheet1Ref.sheet,c=_.isNumber(b)?this._docModel.getSheetModel(b):null;return c?c.getTableCollection().getTable(a):null}return this._docModel.getTable(a)},x.prototype.getValue=function(){return this._value},x.prototype.resolveNameModel=function(a){return this._resolveNameModel(this._value,a)},x.prototype.resolveTableModel=function(){return this._resolveTableModel(this._value)},x.prototype.getText=function(b,c){var d=this._resolveSheetRefs(c),e=a.getStringOption(c,"label",this._value);return b.formatName(this._docModel,d.s1,e)},x.prototype.debugText=function(){return this.debugSheetPrefix()+this._value},x.prototype.resolveRelabeledName=function(a,b,c,d,e){if(c.toLowerCase()!==this._value.toLowerCase())return null;var f=this._resolveNameModel(d,e);if(f){var g=_.isNumber(b)?this._docModel.getSheetModel(b):null;return g!==f.getSheetModel()?null:this.getText(a,{label:d})}};var y=v.extend({constructor:function(a,b,c){v.call(this,"macro",a,c,null),this._value=b}});y.prototype.getValue=function(){return this._value},y.prototype.getText=function(b,c){var d=this._resolveSheetRefs(c),e=a.getStringOption(c,"label",this._value);return b.formatMacro(this._docModel,d.s1,e)},y.prototype.debugText=function(){return this.debugSheetPrefix()+this._value};var z=n.extend({constructor:function(b,c,d){n.call(this,"table"),this._docModel=b,this._tableName=c,this._regionKey=a.getStringOption(d,"regionKey",null),this._regionKeys=this._regionKey?this._regionKey.split(","):null,this._col1Name=a.getStringOption(d,"col1Name",null),this._col2Name=this._col1Name?a.getStringOption(d,"col2Name",null):null,this._openWs=a.getBooleanOption(d,"openWs",!1),this._closeWs=a.getBooleanOption(d,"closeWs",!1),this._sepWs=a.getBooleanOption(d,"sepWs",!1)}});z.prototype._resolveRangeData=function(a){var b=this.resolveTableModel();if(!b)return null;var c=this._regionKey||"DATA",d=!a&&"ROW"===c,e=d?b.getRange():b.getRegionRange(c,a);if(!e)return null;var f=b.getRange();if(this._col1Name){var g=b.findColumnByName(this._col1Name);if(null!==g)if(this._col2Name){var h=b.findColumnByName(this._col2Name);f=null!==h?f.colRange(Math.min(g,h),Math.abs(g-h)+1):null}else f=f.colRange(g);else f=null}return f?{tableModel:b,tableRange:e.intersect(f)}:null},z.prototype.getTableName=function(){return this._tableName},z.prototype.resolveTableModel=function(){return this._docModel.getTable(this._tableName)},z.prototype.getRange3D=function(a){var b=this._resolveRangeData(a);if(!b)return null;var c=b.tableModel.getSheetModel().getIndex();return k.createFromRange(b.tableRange,c)},z.prototype.getText=function(b,c){function d(a){return a?" ":""}var e=a.getStringOption(c,"tableName",this._tableName),f=this._openWs||this._closeWs;if(!this._regionKeys&&!this._col1Name)return e+(b.UI?"":"["+d(f)+"]");var g=this._regionKeys&&1===this._regionKeys.length?this._regionKeys[0]:null,h=[];if(b.UI&&"ROW"===g){var i="";this._col2Name?i="["+b.encodeTableColumn(this._col1Name)+"]:["+b.encodeTableColumn(this._col2Name)+"]":this._col1Name&&(i=b.isSimpleTableColumn(this._col1Name)?this._col1Name:"["+b.encodeTableColumn(this._col1Name)+"]"),h.push("@"+i)}else!g||f||this._col1Name?this._regionKeys||!this._col1Name||this._col2Name||f||/^\s|\s$/.test(this._col1Name)?(this._regionKeys&&this._regionKeys.forEach(function(a){h.push("["+b.getTableRegionName(a)+"]")}),this._col2Name?h.push("["+b.encodeTableColumn(this._col1Name)+"]:["+b.encodeTableColumn(this._col2Name)+"]"):this._col1Name&&h.push("["+b.encodeTableColumn(this._col1Name)+"]")):h.push(b.encodeTableColumn(this._col1Name)):h.push(b.getTableRegionName(g));var j=!0;if(b.UI&&a.getBooleanOption(c,"unqualifiedTables",!1)&&this._col1Name&&!this._col2Name&&(!this._regionKeys||"ROW"===g)){var k=this.resolveTableModel(),l=a.getIntegerOption(c,"refSheet",null);if(k&&k.getSheetModel().getIndex()===l){var m=a.getOption(c,"targetAddress",null);j=!m||!k.containsCell(m)}}return(j?e:"")+"["+d(this._openWs)+h.join(b.SEP+d(this._sepWs))+d(this._closeWs)+"]"},z.prototype.debugText=function(){var a=this._tableName;return this._regionKeys&&(a+=this._regionKeys.map(function(a){return"[#"+a+"]"})),this._col1Name&&(a+="["+this._col1Name+"]"),this._col2Name&&(a+=":["+this._col2Name+"]"),a},z.prototype.resolveDeletedSheet=function(a,b){var c=this.resolveTableModel();return c&&c.getSheetModel().getIndex()!==b?null:a.getErrorName(g.REF)},z.prototype.resolveRenamedSheet=function(a,b,c,d){if(!d)return null;var e=this.resolveTableModel();if(!e)return a.getErrorName(g.REF);var f=d[e.getName()];return f?this.getText(a,{tableName:f}):null},z.prototype.resolveMovedCells=function(a){var b=this._resolveRangeData(null);return b?null:{text:a.getErrorName(g.REF),refError:!0}};var A={FixedToken:o,OperatorToken:p,SeparatorToken:q,ParenthesisToken:r,LiteralToken:s,MatrixToken:t,FunctionToken:u,SheetRefToken:v,ReferenceToken:w,NameToken:x,MacroToken:y,TableToken:z};return A});