define("io.ox/office/spreadsheet/model/formula/tokenarray",["io.ox/office/tk/utils","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/utils/sheetref","io.ox/office/spreadsheet/model/formula/utils/cellref","io.ox/office/spreadsheet/model/formula/parser/tokens"],function(a,b,c,d,e,f){"use strict";function g(a,b){this._docModel=a.getDocModel(),this._sheetModel=a===this._docModel?null:a,this._changeHandlers=null,this._allTokens=[],this._sheetTokens=[],this._refTokens=[],this._nameTokens=[],this._tokenTypeSet={},this._wrapReferences="name"===b,this._freezeRelRefs="name"===b,this._detectCircular="cell"===b,this._unqualifiedTables="cell"===b,this._compileDesc=null,this._interpreting=!1}var h=b.Address,i=b.RangeArray,j=b.Range3DArray,k=f.SeparatorToken,l=f.ParenthesisToken,m=f.SheetRefToken,n=f.ReferenceToken,o=f.NameToken;return g.prototype._registerToken=function(a){this._tokenTypeSet[a.getType()]=!0,a instanceof m&&this._sheetTokens.push(a),a instanceof n&&this._refTokens.push(a),a instanceof o&&this._nameTokens.push(a)},g.prototype._invokeChangeHandlers=function(a,b){this._changeHandlers&&this._changeHandlers.forEach(function(c){c.call(this,a,b)},this)},g.prototype._resolveChangedFormula=function(a,b){var c=this._docModel.getFormulaGrammar(a),d="",e="";return this._allTokens.forEach(function(a){var f=a.getText(c),g=b.call(this,a,c);d+=f,e+=null===g?f:g},this),d===e?null:{old:d,"new":e}},g.prototype._resolveRefSheet=function(b){return this._sheetModel?this._sheetModel.getIndex():a.getIntegerOption(b,"refSheet",null)},g.prototype._extendWithOwnOptions=function(a){return _.extend({},a,{refSheet:this._resolveRefSheet(a),wrapReferences:this._wrapReferences,detectCircular:this._detectCircular,unqualifiedTables:this._unqualifiedTables})},g.prototype._compileTokens=function(a){return this._docModel.getFormulaCompiler().compileTokens(a)},g.prototype.getSheetModel=function(){return this._sheetModel},g.prototype.empty=function(){return 0===this._allTokens.length},g.prototype.hasToken=function(a){return a in this._tokenTypeSet},g.prototype.hasRefTokens=function(){return this.hasToken("ref")||this.hasToken("name")||this.hasToken("table")},g.prototype.getFormula=function(a,b){var c=this._docModel.getFormulaGrammar(a),d=this._extendWithOwnOptions(b);return this._allTokens.reduce(function(a,b){return a+b.getText(c,d)},"")},g.prototype.resolveStringList=function(){var a=[],b="";return this._allTokens.every(function(c){switch(c.getType()){case"lit":return b+="L",a.push(c.getValue()),_.isString(_.last(a));case"sep":return b+=",",!0;case"ws":return!0;default:return b+="I",!1}}),/^L(,L)*$/.test(b)?a:null},g.prototype.resolveRangeList=function(b){var c=new j;if(this._interpreting)return c;var d=a.getBooleanOption(b,"resolveNames",!1),e=d?this.hasRefTokens():this.hasToken("ref");if(!e)return c;var f=a.getOption(b,"targetAddress",h.A1);b=this._extendWithOwnOptions(b);var g="",i=this._allTokens.every(function(a){switch(a.getType()){case"ref":var e=a.getRange3D(b);return e&&e.singleSheet()?(c.push(e),g+="R",!0):!1;case"name":var i=d?a.resolveNameModel(b.refSheet):null;if(!i)return!1;var j=_.clone(b);j.refAddress=h.A1,this._interpreting=!0;var k=i.getTokenArray().resolveRangeList(j);return this._interpreting=!1,k.empty()?!1:(c.append(k),g+="R",!0);case"table":var l=d?a.getRange3D(f):null;return l?(c.push(l),g+="R",!0):!1;case"open":return g+="<",!0;case"close":return g+=">",!0;case"sep":return g+=",",!0;case"ws":return!0;default:return!1}},this);return i&&/^(R(,R)*|<R(,R)*>)$/.test(g)?c:c.clear()},g.prototype.extractRanges=function(b){var c=[];if(c.circular=!1,this._interpreting)return c.circular=!0,c;var d=a.getBooleanOption(b,"resolveNames",!1),e=d?this.hasRefTokens():this.hasToken("ref");if(!e)return c;var f=a.getOption(b,"targetAddress",h.A1);return b=this._extendWithOwnOptions(b),this._allTokens.forEach(function(a,e){switch(a.getType()){case"ref":var g=a.getRange3D(b);g&&c.push({range:g,index:e,type:"ref"});break;case"name":var i=d?a.resolveNameModel(b.refSheet):null;if(!i)return;var j=_.clone(b);j.refAddress=h.A1,this._interpreting=!0;var k=i.getTokenArray().extractRanges(j);this._interpreting=!1,k.forEach(function(a){c.push({range:a.range,index:e,type:"name"})}),c.circular=c.circular||k.circular;break;case"table":var l=d?a.getRange3D(f):null;l&&c.push({range:l,index:e,type:"table"})}},this),c},g.prototype.resolveOperation=function(b,c){var d=this._resolveRefSheet();switch(c.type){case"deleteSheet":return 0!==this._sheetTokens.length||this.hasToken("table")?this._resolveChangedFormula(b,function(a,b){return a.resolveDeletedSheet(b,c.sheet,d)}):null;case"renameSheet":return 0!==this._sheetTokens.length||this.hasToken("table")?this._resolveChangedFormula(b,function(a,b){return a.resolveRenamedSheet(b,c.sheet,c.sheetName,c.tableNames)}):null;case"relabelName":return 0===this._nameTokens.length?null:this._resolveChangedFormula(b,function(a,b){return a.resolveRelabeledName(b,c.sheet,c.oldLabel,c.newLabel,d)});case"moveCells":if(!this.hasToken("ref")&&!this.hasToken("table"))return null;var e={refSheet:d,freezeRelRefs:this._freezeRelRefs};c.relocate&&(e.refAddress=c.relocate.from,e.targetAddress=c.relocate.to);var f=!1,g=this._resolveChangedFormula(b,function(a,b){var d=a.resolveMovedCells(b,c.sheet,c.moveDescs,e);return d?(f=f||d.refError,d.text):null});return g&&(g.error=f),g}return a.error('TokenArray.resolveOperation(): unknown operation type "'+c.type+'"'),null},g.prototype.registerChangeHandler=function(a){return(this._changeHandlers||(this._changeHandlers=[])).push(a),this},g.prototype.unregisterChangeHandler=function(a){return this._changeHandlers&&(this._changeHandlers=_.without(this._changeHandlers,a)),this},g.prototype.setTokens=function(a){return this.empty()&&0===a.length?this:(this._allTokens=a.slice(),this._refTokens=[],this._sheetTokens=[],this._tokenTypeSet={},this._allTokens.forEach(this._registerToken,this),this._compileDesc=null,this._invokeChangeHandlers(null),this)},g.prototype.clearTokens=function(){return this.setTokens([])},g.prototype.parseFormula=function(b,c,d){d=this._extendWithOwnOptions(d);var e=this._docModel.getFormulaParser(),f=e.parseFormula(b,c,d),g=_.pluck(f,"token");if(a.getBooleanOption(d,"autoCorrect",!1)){var h=this._compileTokens(g);if(!h.error)for(var i=0;i<h.missingClose;i+=1)g.push(new l(!1))}return this.setTokens(g),f},g.prototype.refreshAfterImport=function(a){return this.hasToken("bad")?this.parseFormula("op",this.getFormula("op"),a):(this._sheetTokens.forEach(function(a){a.refreshSheets()}),this._compileDesc=null),this},g.prototype.modifyToken=function(a,b,c,d){var e=this._allTokens[a];return e&&e.isType(b)&&c.call(d,e,a)&&this._invokeChangeHandlers(e,a),this},g.prototype.appendToken=function(a){return this._allTokens.push(a),this._registerToken(a),this._compileDesc=null,this._invokeChangeHandlers(a,this._allTokens.length-1),this},g.prototype.appendRange=function(b,c){var f=this._docModel.isColRange(b),g=this._docModel.isRowRange(b),h=a.getBooleanOption(c,"abs",!1),i=e.create(b.start,h||g,h||f&&!g),j=b.single()?null:e.create(b.end,h||g,h||f&&!g),k=a.getIntegerOption(c,"sheet"),l="number"==typeof k?new d(k,!0):null;return this.appendToken(new n(this._docModel,i,j,l))},g.prototype.appendRangeList=function(b,c){var d=b.length>1&&a.getBooleanOption(c,"parentheses",!1);return d&&this.appendToken(new l(!0)),b.forEach(function(a,b){b>0&&this.appendToken(new k),this.appendRange(a,c)},this),d&&this.appendToken(new l(!1)),this},g.prototype.relocateRanges=function(a,b){if(a.equals(b))return!1;var c=!1;return this._refTokens.forEach(function(d){d.relocateRange(a,b,this._wrapReferences)&&(c=!0)},this),c&&this._invokeChangeHandlers(null),c},g.prototype.transformSheet=function(a,b){if(a===b)return!1;var c=!1;return this._sheetTokens.forEach(function(d){d.transformSheet(a,b)&&(c=!0)},this),c&&this._invokeChangeHandlers(null),c},g.prototype.compileFormula=function(){return this._compileDesc||(this._compileDesc=this._compileTokens(this._allTokens))},g.prototype.getDependencies=function(a,d,e){var f={depRanges:new j,rootRanges:new j,names:{},missingNames:{},recalc:null,circular:!1},g=this.compileFormula();if(g.error)return f;if(this._interpreting)return f.circular=!0,f;f.recalc=g.root.recalc,e=this._extendWithOwnOptions(e);var k=d instanceof h?d:null,l=k?_.extend({},e,{refAddress:a,targetAddress:k}):null,m=k?null:i.get(d),n=function o(g){var i=g.token;if(i.isType("ref")){if(l){var n=i.getRange3D(l);return n?new j(n):null}return i.getExpandedRanges(a,m,e)}if(i.isType("name")){var p=i.resolveNameModel(e.refSheet);if(!p)return f.missingNames[b.getNameKey(i.getValue())]=!0,null;this._interpreting=!0;var q=p.getTokenArray().getDependencies(h.A1,d,e);return this._interpreting=!1,f.depRanges.append(q.depRanges),f.names[p.getUid()]=p,_.extend(f.names,q.names),_.extend(f.missingNames,q.missingNames),f.recalc=c.getRecalcMode(f.recalc,q.recalc),f.circular=f.circular||q.circular,q.rootRanges}if(i.isType("table")){var r=i.getRange3D(k);return r?new j(r):null}if(g.operands&&g.signature){var s=new j;return g.signature.forEach(function(a,b){var c=o.call(this,g.operands[b]);switch(a.depSpec){case"pass":s.append(c);break;case"skip":break;default:f.depRanges.append(c)}},this),s}return null}.call(this,g.root);return f.rootRanges.append(n),f},g.prototype.interpretFormula=function(a,b){var d=this.compileFormula(),e=this._docModel.getFormulaInterpreter();if(d.error)return e.createErrorResult(d.error);if(this._interpreting)return e.createResult(c.CIRCULAR_ERROR);try{return this._interpreting=!0,e.interpretTokens(a,d.root,this._extendWithOwnOptions(b))}finally{this._interpreting=!1}},g});