define("io.ox/office/spreadsheet/model/model",["io.ox/office/tk/utils","io.ox/office/tk/utils/simplemap","io.ox/office/tk/utils/iteratorutils","io.ox/office/tk/locale/localedata","io.ox/office/editframework/model/editmodel","io.ox/office/spreadsheet/utils/config","io.ox/office/spreadsheet/utils/operations","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/utils/operationcontext","io.ox/office/spreadsheet/model/operationsgenerator","io.ox/office/spreadsheet/model/numberformatter","io.ox/office/spreadsheet/model/namecollection","io.ox/office/spreadsheet/model/listcollection","io.ox/office/spreadsheet/model/sheetmodel","io.ox/office/spreadsheet/model/modelattributesmixin","io.ox/office/spreadsheet/model/viewsettingsmixin","io.ox/office/spreadsheet/model/formula/parser/formularesource","io.ox/office/spreadsheet/model/formula/parser/formulagrammar","io.ox/office/spreadsheet/model/formula/parser/formulaparser","io.ox/office/spreadsheet/model/formula/formulacompiler","io.ox/office/spreadsheet/model/formula/formulainterpreter","io.ox/office/spreadsheet/model/formula/deps/dependencymanager"],function(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v){"use strict";function w(w){function F(a,b){la[0]=a-1,la[1]=b-1}function G(a){return a=_.isNumber(a)?a:_.isString(a)?Z.getSheetIndex(a):-1,a>=0&&a<ba.length?ba[a]:null}function H(a,b){var c=Z.getSheetModel(a),d=_.isNumber(b)?Z.getSheetModel(b):null;return 0===a.length?"sheetname:empty":/^'|[\x00-\x1f\x80-\x9f\[\]*?:\/\\]|'$/.test(a)?"sheetname:invalid":!_.isObject(c)||_.isObject(d)&&c===d?null:"sheetname:used"}function I(a,b){return null===H(a,b)}function J(a,b){var c=H(a,b);return null===c?$.when():h.makeRejected(c)}function K(a,b,c,d){if(Z.getSheetCount()===f.MAX_SHEET_COUNT)return null;var e=new n(Z,b,d);return Z.trigger("insert:sheet:before",a),a<ba.length&&ca.clear(),ba.splice(a,0,{model:e,name:c}),Z.trigger("insert:sheet:after",a,e),Z.trigger("transform:sheet",a,null),Z.listenTo(e,"triggered",function(a,b){var c=D[b]||b;Z.trigger.apply(Z,[c,e.getIndex()].concat(_.toArray(arguments).slice(2)))}),e}function L(a){var b=a.getInt("sheet"),c=a.getStr("sheetName"),d=a.getOptEnum("type",/^(work|chart|macro|dialog)sheet$/,"worksheet"),e=a.getOptObj("attrs");a.ensure(!E,"debug mode: insert sheet fails"),a.ensure(b>=0&&b<=Z.getSheetCount(),"invalid sheet index"),a.ensure(I(c),"invalid sheet name");var f=K(b,d,c,e);a.ensure(f,"cannot create sheet")}function M(a,b,c){a.ensure(Z.getSheetCount()>1,"cannot delete last sheet"),Z.trigger("delete:sheet:before",c,b),b.destroy(),ba.splice(c,1),c<ba.length&&ca.clear(),Z.trigger("delete:sheet:after",c),Z.trigger("transform:sheet",null,c)}function N(a,b,c){var d=G(c),e=a.getStr("sheetName");a.ensure(I(e,c),"invalid sheet name"),d.name!==e&&(d.name=e,Z.trigger("rename:sheet",c,e,b))}function O(a,b,c){var d=a.getInt("to");a.ensure(d>=0&&d<=Z.getSheetCount(),"invalid target index");var e=ba[c];Z.trigger("move:sheet:before",c,d,b),ba.splice(c,1),ba.splice(d,0,e),ca.clear(),Z.trigger("move:sheet:after",c,d,b),Z.trigger("transform:sheet",c,d)}function P(a,b){var c=a.getInt("to");a.ensure(c>=0&&c<=Z.getSheetCount(),"invalid target index");var d=a.getStr("sheetName");a.ensure(I(d),"invalid sheet name");var e=K(c,b.getType(),d);a.ensure(e,"cannot create sheet"),e.applyCopySheetOperation(a,b)}function Q(a){if(0===arguments.length){var b=Z.getActiveSheet(),c=Z.getSheetModel(b);return c?{sheet:b,selection:c.getViewAttribute("selection")}:null}var d=Z.getSheetModel(a.sheet);d&&(Z.setActiveSheet(a.sheet),d.setViewAttribute("selection",a.selection))}function R(a){var b=a.filter(function(a){return a.remote&&_.isObject(a.userData)&&_.isNumber(a.userData.sheet)&&_.isString(a.userData.ranges)});Z.setViewAttribute("remoteClients",b)}function S(a,b,c){Z.registerContextOperationHandler(a,function(a){b[c](a)})}function T(b,c,d){var e=a.getBooleanOption(d,"allowDoc",!1);return Z.registerContextOperationHandler(b,function(a){var b=e&&!a.has("sheet"),d=b?null:a.getInt("sheet"),f=b?Z:Z.getSheetModel(d);return a.ensure(f,"missing sheet"),c.call(Z,a,f,d)})}function U(a,b,c){T(a,function(a,c){c[b](a)},c)}function V(a,b,c,d){T(a,function(a,d){d[b]()[c](a)},d)}function W(a,b){return Z.registerContextOperationHandler(a,function(a){var c=a.getArr("start");a.ensure(c.length>=2&&c.every(_.isNumber),"invalid drawing position");var d=Z.getSheetModel(c[0]);return a.ensure(d,"missing sheet"),b.call(Z,a,d.getDrawingCollection(),c.slice(1))})}function X(a,b){W(a,function(a,c,d){c[b](a,d)})}function Y(a,b,c){W(a,function(a,d,e){var f=d.findModel(e,{deep:!0,type:c});a.ensure(f,"invalid drawing position"),f[b](a)})}var Z=this,aa=w.getFileFormat(),ba=[],ca=new b,da=new b,ea=null,fa=null,ga=null,ha=null,ia=null,ja=null,ka=null,la=x.A1.clone(),ma=[];e.call(this,w,{generatorClass:j,contextClass:i,selectionStateHandler:Q});var na=this.createDebouncedMethod(_.noop,function(){var a=Q();a&&w.updateUserData({sheet:a.sheet,ranges:ga.formatRangeList("op",a.selection.ranges),drawings:a.selection.drawings})},{delay:250});this.postProcessImport=function(){return 0===this.getSheetCount()?$.Deferred().reject():(this.getCellStyles().createMissingStyles(),this.iterateSliced(this.createSheetIterator(),function(a){return a.postProcessImport()}))},this._registerTableModel=function(a){a.isAutoFilter()||da.insert(a.getKey(),a)},this._unregisterTableModel=function(a){a.isAutoFilter()||da.remove(a.getKey())},this.getNumberFormatter=function(){return ea},this.getFormulaResource=function(){return q.create(aa,d.LOCALE)},this.getFormulaGrammar=function(a){return r.create(aa,a)},this.getFormulaParser=function(){return ga},this.getFormulaCompiler=function(){return ha},this.getFormulaInterpreter=function(){return ia},this.getNameCollection=function(){return ja},this.getListCollection=function(){return ka},this.getDependencyManager=function(){return fa},this.getMaxCol=function(){return la[0]},this.getMaxRow=function(){return la[1]},this.getMaxIndex=function(a){return la.get(a)},this.getMaxAddress=function(){return la.clone()},this.getSheetRange=function(){return z.createFromAddresses(x.A1,la)},this.isColRange=function(a){return 0===a.start[1]&&a.end[1]===la[1]},this.makeColRange=function(a){return z.create(_.isNumber(a)?a:a.first,0,_.isNumber(a)?a:a.last,la[1])},this.makeColRanges=function(a){return A.map(a,this.makeColRange.bind(this))},this.isRowRange=function(a){return 0===a.start[0]&&a.end[0]===la[0]},this.makeRowRange=function(a){return z.create(0,_.isNumber(a)?a:a.first,la[0],_.isNumber(a)?a:a.last)},this.makeRowRanges=function(a){return A.map(a,this.makeRowRange.bind(this))},this.isFullRange=function(a,b){return b?this.isColRange(a):this.isRowRange(a)},this.makeFullRange=function(a,b){return b?this.makeColRange(a):this.makeRowRange(a)},this.makeFullRanges=function(a,b){return b?this.makeColRanges(a):this.makeRowRanges(a)},this.isValidAddress=function(a){return a[0]>=0&&a[0]<=la[0]&&a[1]>=0&&a[1]<=la[1]},this.isValidRange=function(a){return a.start[0]>=0&&a.start[0]<=a.end[0]&&a.end[0]<=la[0]&&a.start[1]>=0&&a.start[1]<=a.end[1]&&a.end[1]<=la[1]},this.createInterval=function(a,b,c){if(!_.isObject(a))return null;var d=c?"start":"first",e=c?"end":"last",f=this.getMaxIndex(b),g=a[d];if(!_.isNumber(g)||!isFinite(g)||0>g||g>f)return null;if(!(e in a))return new y(g);var h=a[e];return!_.isNumber(h)||!isFinite(h)||g>h||h>f?null:new y(g,h)},this.createAddress=function(a){return _.isArray(a)&&2===a.length?!_.isNumber(a[0])||!isFinite(a[0])||a[0]<0||a[0]>la[0]?null:!_.isNumber(a[1])||!isFinite(a[1])||a[1]<0||a[1]>la[1]?null:new x(a[0],a[1]):null},this.createRange=function(a){if(!_.isObject(a))return null;var b=this.createAddress(a.start);if(!b)return null;if(!("end"in a))return new z(b);var c=this.createAddress(a.end);return!c||c[0]<b[0]||c[1]<b[1]?null:new z(b,c)},this.createRangeArray=function(a){if(!_.isArray(a)||0===a.length)return null;var b=new A;return a.every(function(a){return a=this.createRange(a),a?(b.push(a),!0):void 0},this),a.length===b.length?b:null},this.getBoundedMovedRange=function(b,c,d){return c=a.minMax(c,-b.start[0],la[0]-b.end[0]),d=a.minMax(d,-b.start[1],la[1]-b.end[1]),z.create(b.start[0]+c,b.start[1]+d,b.end[0]+c,b.end[1]+d)},this.getCroppedMovedRange=function(a,b,c){var d=Math.max(0,a.start[0]+b),e=Math.max(0,a.start[1]+c),f=Math.min(la[0],a.end[0]+b),g=Math.min(la[1],a.end[1]+c);return f>=d&&g>=e?z.create(d,e,f,g):null},this.getMaxSheetNameLength=function(){return w.isOOXML()?31:65535},this.getSheetCount=function(){return ba.length},this.getSheetNames=function(){return _.pluck(ba,"name")},this.hasSheet=function(a){return _.isObject(G(a))},this.getSheetName=function(a){var b=G(a);return b?b.name:null},this.getSheetIndex=function(b){return b=b.toLowerCase(),a.findFirstIndex(ba,function(a){return a.name.toLowerCase()===b})},this.getSheetIndexOfModel=function(b){return ca.getOrCreate(b.getUid(),function(){return a.findFirstIndex(ba,function(a){return a.model===b})})},this.getSheetModel=function(a){var b=G(a);return b?b.model:null},this.createSheetIntervalIterator=function(b,d,e){var f=c.createArrayIterator(ba,{begin:b,end:d+1}),g=a.getTokenListOption(e,"types",null),h=g?a.makeSet(g):null,i=a.getBooleanOption(e,"visible",null);return c.createTransformIterator(f,function(a,b){var c=a.model,d=!h||c.getType()in h;return d&&(d=null===i||i===a.model.getMergedAttributeSet(!0).sheet.visible),d?{value:a.model,name:a.name,sheet:b.index}:null})},this.createSheetIterator=function(a){return this.createSheetIntervalIterator(0,ba.length-1,a)},this.getActiveSheet=function(){return this.getViewAttribute("activeSheet")},this.setActiveSheet=function(a){return this.setViewAttribute("activeSheet",a)},this.generateUnusedSheetName=function(){for(var a="",b=this.getSheetCount();0===a.length||this.hasSheet(a);)a=h.getSheetName(b),b+=1;return a},this.hasName=function(a){return ja.hasName(a)||ba.some(function(b){return b.model.getNameCollection().hasName(a)})},this.getAllNames=function(b){var c=ja.getAllNames(b);return a.getBooleanOption(b,"skipLocal",!1)||ba.forEach(function(a){c=c.concat(a.model.getNameCollection().getAllNames(b))}),c},this.hasTable=function(a){return da.has(h.getTableKey(a))},this.getTable=function(a){return da.get(h.getTableKey(a),null)},this.getAllTables=function(a){return ba.reduce(function(b,c){return b.concat(c.model.getTableCollection().getAllTables(a))},[])},this.getRangeContents=function(b,c){var d=a.getIntegerOption(c,"maxCount",null,1),e=[];return e.count=0,b=B.filter(b,function(b){return this.hasSheet(b.sheet1)&&b.singleSheet()?!0:(a.warn("SpreadsheetModel.getRangeContents(): invalid sheet index in range address"),!1)},this),c=_.clone(c),B.forEach(b,function(b){var f=this.getSheetModel(b.sheet1).getCellCollection(),g=b.toRange(),h=f.getRangeContents(g,c);return e=e.concat(h),e.count+=h.count,d===e.count?a.BREAK:void(d&&(c.maxCount-=h.count))},this),e},this.sendOperations=h.profileAsyncMethod("SpreadsheetModel.sendOperations()",_.wrap(this.sendOperations,function(b,c,d){return a.getBooleanOption(d,"defer",!1)?(ma=ma.concat(j.getArray(c,d)),!0):b.call(this,c,d)})),this.createAndApplyOperations=h.profileAsyncMethod("SpreadsheetModel.createAndApplyOperations()",_.wrap(this.createAndApplyOperations,function(a,b,c){return ma.length>0&&(this.sendOperations(ma),ma=[]),a.call(this,function(a){return b.call(this,a).always(function(){a.logCacheUsage()})},_.extend({applyImmediately:!0},c))})),this.generateOperationsForAllSheets=function(b,c,d){var e=b.getSheetIndex(),f=a.getIntegerOption(d,"skipSheet",null),g=this.iterateSliced(this.createSheetIterator(d),function(a,d){return d.sheet!==f?(b.setSheetIndex(d.sheet),c.call(Z,a,d.sheet)):void 0},{delay:"immediate"});return g.done(function(){b.setSheetIndex(e)})},this.generateInsertSheetOperations=function(a,b,c,d){return J(c).then(function(){var e={sheet:b,sheetName:c};_.isObject(d)&&(e.attrs=d),a.setSheetIndex(b),a.generateSheetOperation(g.DELETE_SHEET,null,{undo:!0,prepend:!0}),a.generateSheetOperation(g.INSERT_SHEET,{sheetName:c})})},this.generateDeleteSheetOperations=function(b,c){var d={type:"deleteSheet",sheet:c},e=ja.generateFormulaOperations(b,d);return e=e.then(function(){return Z.generateOperationsForAllSheets(b,function(c){return a.invokeChainedAsync(function(){return c.getCellCollection().generateFormulaOperations(b,d)},function(){return c.getNameCollection().generateFormulaOperations(b,d)},function(){return c.getValidationCollection().generateFormulaOperations(b,d)},function(){return c.getCondFormatCollection().generateFormulaOperations(b,d)},function(){return c.getDrawingCollection().generateFormulaOperations(b,d)})},{skipSheet:c})}),e=e.then(function(){return b.setSheetIndex(c),Z.getSheetModel(c).generateRestoreOperations(b)}),e.done(function(){b.setSheetIndex(c),b.generateSheetOperation(g.DELETE_SHEET)})},this.generateMoveSheetOperations=function(a,b,c){return a.setSheetIndex(c).generateSheetOperation(g.MOVE_SHEET,{to:b},{undo:!0,prepend:!0}),a.setSheetIndex(b).generateSheetOperation(g.MOVE_SHEET,{to:c}),$.when()},this.generateCopySheetOperations=function(b,c,d,e){return J(e).then(function(){var f={};Z.getAllTables().forEach(function(a){f[a.getKey()]=!0});var i=Z.getSheetModel(c),j={};i.getTableCollection().getAllTables().forEach(function(a){for(var b=a.getName(),c=/^(.*?)(\d+)$/.exec(b),d=c?c[1]:h.getTableName(),e=c?parseInt(c[2],10)+1:1;h.getTableKey(d+e)in f;)e+=1;var g=d+e;f[h.getTableKey(g)]=!0,j[b]=g});var k={to:d,sheetName:e,tableNames:j};b.setSheetIndex(c).generateSheetOperation(g.COPY_SHEET,k);var l=Z.getSheetModel(d),m={type:"renameSheet",sheet:c,sheetName:e,tableNames:j};b.setSheetIndex(d);var n=a.invokeChainedAsync(function(){return l.getCellCollection().generateFormulaOperations(b,m)},function(){return l.getNameCollection().generateFormulaOperations(b,m)},function(){return l.getValidationCollection().generateFormulaOperations(b,m)},function(){return l.getCondFormatCollection().generateFormulaOperations(b,m)},function(){return l.getDrawingCollection().generateFormulaOperations(b,m)});return n.done(function(){b.clearOperations({undo:!0}),b.generateSheetOperation(g.DELETE_SHEET,null,{undo:!0})})})},this.generateRenameSheetOperations=function(b,c,d){var e=this.getSheetName(c);return e===d?$.when():J(d,c).then(function(){var f=Z.createOperationsGenerator(),h={type:"renameSheet",sheet:c,sheetName:d},i=ja.generateFormulaOperations(f,h);return i=i.then(function(){return Z.generateOperationsForAllSheets(f,function(b){return a.invokeChainedAsync(function(){return b.getCellCollection().generateFormulaOperations(f,h)},function(){return b.getNameCollection().generateFormulaOperations(f,h)},function(){return b.getValidationCollection().generateFormulaOperations(f,h)},function(){return b.getCondFormatCollection().generateFormulaOperations(f,h)},function(){return b.getDrawingCollection().generateFormulaOperations(f,h)})})}),i.done(function(){b.setSheetIndex(c),b.generateSheetOperation(g.RENAME_SHEET,{sheetName:e},{undo:!0}),b.generateSheetOperation(g.RENAME_SHEET,{sheetName:d}),b.appendOperations(f,{undo:!0}),b.appendOperations(f)})})},ea=new k(this),fa=new v(this),ga=new s(this),ha=new t(this),ia=new u(this),ja=new l(this),ka=new m(this),o.call(this),p.call(this,C),"ooxml"===aa&&(S(g.INSERT_NUMBER_FORMAT,ea,"applyInsertOperation"),S(g.DELETE_NUMBER_FORMAT,ea,"applyDeleteOperation")),this.registerContextOperationHandler(g.INSERT_SHEET,L),T(g.DELETE_SHEET,M),T(g.RENAME_SHEET,N),T(g.MOVE_SHEET,O),T(g.COPY_SHEET,P),U(g.CHANGE_SHEET,"applyChangeSheetOperation"),V(g.CHANGE_CELLS,"getCellCollection","applyChangeCellsOperation"),V(g.INSERT_CELLS,"getCellCollection","applyInsertCellsOperation"),V(g.DELETE_CELLS,"getCellCollection","applyDeleteCellsOperation"),V(g.INSERT_HYPERLINK,"getHyperlinkCollection","applyInsertHyperlinkOperation"),V(g.DELETE_HYPERLINK,"getHyperlinkCollection","applyDeleteHyperlinkOperation"),V(g.MERGE_CELLS,"getMergeCollection","applyMergeCellsOperation"),V(g.INSERT_COLUMNS,"getColCollection","applyInsertOperation"),V(g.DELETE_COLUMNS,"getColCollection","applyDeleteOperation"),V(g.CHANGE_COLUMNS,"getColCollection","applyChangeOperation"),V(g.INSERT_ROWS,"getRowCollection","applyInsertOperation"),V(g.DELETE_ROWS,"getRowCollection","applyDeleteOperation"),V(g.CHANGE_ROWS,"getRowCollection","applyChangeOperation"),V(g.INSERT_NAME,"getNameCollection","applyInsertOperation",{allowDoc:!0}),V(g.DELETE_NAME,"getNameCollection","applyDeleteOperation",{allowDoc:!0}),V(g.CHANGE_NAME,"getNameCollection","applyChangeOperation",{allowDoc:!0}),V(g.INSERT_TABLE,"getTableCollection","applyInsertOperation"),V(g.DELETE_TABLE,"getTableCollection","applyDeleteOperation"),V(g.CHANGE_TABLE,"getTableCollection","applyChangeOperation"),V(g.CHANGE_TABLE_COLUMN,"getTableCollection","applyChangeColumnOperation"),V(g.INSERT_VALIDATION,"getValidationCollection","applyInsertOperation"),V(g.DELETE_VALIDATION,"getValidationCollection","applyDeleteOperation"),V(g.CHANGE_VALIDATION,"getValidationCollection","applyChangeOperation"),V(g.INSERT_CFRULE,"getCondFormatCollection","applyInsertOperation"),V(g.DELETE_CFRULE,"getCondFormatCollection","applyDeleteOperation"),V(g.CHANGE_CFRULE,"getCondFormatCollection","applyChangeOperation"),X(g.INSERT_DRAWING,"applyInsertDrawingOperation"),X(g.DELETE_DRAWING,"applyDeleteDrawingOperation"),Y(g.SET_DRAWING_ATTRIBUTES,"applySetAttributesOperation"),Y(g.INSERT_CHART_DATASERIES,"applyInsertSeriesOperation","chart"),Y(g.DELETE_CHART_DATASERIES,"applyDeleteSeriesOperation","chart"),Y(g.SET_CHART_DATASERIES_ATTRIBUTES,"applyChangeSeriesOperation","chart"),Y(g.SET_CHART_AXIS_ATTRIBUTES,"applyChangeAxisOperation","chart"),Y(g.SET_CHART_GRIDLINE_ATTRIBUTES,"applyChangeGridOperation","chart"),Y(g.SET_CHART_TITLE_ATTRIBUTES,"applyChangeTitleOperation","chart"),Y(g.SET_CHART_LEGEND_ATTRIBUTES,"applyChangeLegendOperation","chart"),this.listenTo(ja,"triggered",function(a,b){Z.trigger.apply(Z,[b,null].concat(_.toArray(arguments).slice(2)))}),F(this.getDocumentAttribute("cols"),this.getDocumentAttribute("rows")),this.on("change:attributes",function(a,b){F(b.cols,b.rows)}),this.on("change:viewattributes",function(a,b){"activeSheet"in b&&na()}),this.on("change:sheet:viewattributes",function(a,b,c){"selection"in c&&b===Z.getActiveSheet()&&na()}),this.listenTo(w,"docs:users:selection",R),this.registerDestructor(function(){_.chain(ba).pluck("model").invoke("destroy"),ja.destroy(),ka.destroy(),ia.destroy(),ha.destroy(),ga.destroy(),fa.destroy(),ea.destroy(),ba=ca=da=null,ga=ha=ia=null,fa=ea=ja=ka=null})}var x=h.Address,y=h.Interval,z=h.Range,A=h.RangeArray,B=h.Range3DArray,C={activeSheet:{def:-1,validate:function(b){return b>=-1&&b<this.getSheetCount()?b:a.BREAK}},remoteClients:{def:[],validate:function(a){return _.isArray(a)?a:[]}}},D={"change:attributes":"change:sheet:attributes","change:viewattributes":"change:sheet:viewattributes"},E=f.getDebugUrlFlag("spreadsheet:failing-import");return e.extend({constructor:w})});