define("io.ox/office/spreadsheet/model/operationsgenerator",["io.ox/office/tk/utils","io.ox/office/tk/utils/simplemap","io.ox/office/editframework/utils/border","io.ox/office/editframework/model/operationsgenerator","io.ox/office/spreadsheet/utils/sheetutils"],function(a,b,c,d,e){"use strict";var f=d.extend({constructor:function(c,e){d.call(this,c,e),this._autoStyles=c.getCellAutoStyles(),this._styleIdCache=new b,this._cacheHits=0,this._cacheMisses=0,this._sheet=a.getIntegerOption(e,"sheet",0)}});return f.prototype._getCachedStyleId=function(a,b){var c=b?this._styleIdCache.get(b):null;if(!c)return null;var d=c.get(a,null);return null!==d&&(this._cacheHits+=1),d},f.prototype._setCachedStyleId=function(a,c,d){d&&(this._styleIdCache.getOrConstruct(d,b).insert(a,c),this._cacheMisses+=1)},f.prototype.getSheetIndex=function(){return this._sheet},f.prototype.setSheetIndex=function(a){return this._sheet=a,this},f.prototype.generateSheetOperation=function(a,b,c){return b=_.extend({sheet:this._sheet},b),this.generateOperation(a,b,c)},f.prototype.generateIntervalOperation=function(a,b,c,d){return c=_.extend({start:b.first},c),(b.first<b.last||d&&d.complete)&&(c.end=b.last),this.generateSheetOperation(a,c,d)},f.prototype.generateCellOperation=function(a,b,c,d){return c=_.extend({start:b.toJSON()},c),this.generateSheetOperation(a,c,d)},f.prototype.generateRangeOperation=function(a,b,c,d){return c=_.extend({start:b.start.toJSON()},c),(!b.single()||d&&d.complete)&&(c.end=b.end.toJSON()),this.generateSheetOperation(a,c,d)},f.prototype.generateRangesOperation=function(a,b,c,d){var e=d&&d.complete;return b=b.map(function(a){var b={start:a.start.toJSON()};return(e||!a.single())&&(b.end=a.end.toJSON()),b}),c=_.extend({ranges:b},c),this.generateSheetOperation(a,c,d)},f.prototype.generateTableOperation=function(a,b,c,d){return b.length>0&&(c=_.extend({table:b},c)),this.generateSheetOperation(a,c,d)},f.prototype.generateDrawingOperation=function(a,b,c,d){return c=_.extend({start:[this._sheet].concat(b)},c),this.generateOperation(a,c,d)},f.prototype.isDefaultStyleId=function(a){return this._autoStyles.isDefaultStyleId(a)},f.prototype.areEqualStyleIds=function(a,b){return this._autoStyles.areEqualStyleIds(a,b)},f.prototype.generateAutoStyle=function(b,c){if(!("s"in c||"a"in c||"format"in c))return b;var d=this._getCachedStyleId(b,c.cacheKey);if(null!==d)return d;if(d="string"==typeof c.s?c.s:b,_.isObject(c.a)||"format"in c){var e=a.getFunctionOption(c,"processAttributes");d=this._autoStyles.generateAutoStyleOperation(this,d,c,e)}return this._setCachedStyleId(b,d,c.cacheKey),d},f.prototype.generateInsertedAutoStyle=function(a,b,d){function f(a,b,d){var e=a[b],f=a[d];return e&&f&&c.isEqual(e,f)}function g(a,b){var d=j[a],e=k[b];return d&&e&&c.isEqual(d,e)?d:null}if(this.areEqualStyleIds(a,b))return a;var h=a+"\n"+b,i=this._getCachedStyleId(a,h);if(null!==i)return i;var j=this._autoStyles.getBorderMap(a),k=this._autoStyles.getBorderMap(b);if(_.isEmpty(j)&&_.isEmpty(k))return a;var l={},m=e.getOuterBorderKey(!d,!0);l[e.getBorderName(m)]=g(m,m);var n=e.getOuterBorderKey(!d,!1);l[e.getBorderName(n)]=g(n,n);var o=e.getOuterBorderKey(d,!0),p=e.getOuterBorderKey(d,!1),q=g(p,o),r=q&&(f(j,o,p)||f(k,o,p));return l[e.getBorderName(o)]=l[e.getBorderName(p)]=r?q:null,this.generateAutoStyle(a,{a:{cell:l},cacheKey:h})},f.prototype.createBorderContents=function(){function a(a,b,d){var f=b.cell,g=a.cell;_.each("tblrdu",function(a){var b=e.getBorderName(a);if(b in g){var h=f[b],i=g[b];c.isVisibleBorder(i)||(!c.isVisibleBorder(h)||c.isEqual(h,d[b]))&&delete g[b]}})}function b(b,g){function h(b,c){return a(b,c,k)}var i={},j={},k={},l=0;return b.forEach(function(a){var b=a.key,c=i[b]||(i[b]={});_.extend(c,a)}),_.each(i,function(a,b){var g=e.getBorderName(b),h=f[b];a.border?(j[g]=a.border,l|=h*d[a.cacheType]):a.keepBorder&&(j[g]=c.NONE,k[g]=a.keepBorder,l|=h*d.clear)}),{a:{cell:j},cacheKey:g+":"+l,processAttributes:h}}var d={outer:1,inner:2,clear:3},f={t:1,b:4,l:16,r:64};return b}(),f.prototype.createVisibleBorderContents=function(){function a(a,b){var d=b.cell,f=a.cell;_.each("tblrdu",function(a){var b=e.getBorderName(a);if(b in f){var g=d[b],h=f[b];c.isVisibleBorder(g)?(h=_.extend({},g,h),f[b]=c.isVisibleBorder(h)?h:c.NONE):delete f[b]}})}function b(b,c,f){var g={},h=0;return b.forEach(function(a){_.each(a.keys,function(a){g[e.getBorderName(a)]=c,h|=d[a]})}),{a:{cell:g},cacheKey:f+":"+h,processAttributes:a}}var d={t:1,b:2,l:4,r:8,d:16,u:32};return b}(),f.prototype.logCacheUsage=e.isLoggingActive()?function(){var a=this._cacheHits+this._cacheMisses;a>0&&(e.log("style cache hits: "+this._cacheHits+" ("+Math.round(this._cacheHits/a*100)+"%)"),e.log("style cache miss: "+this._cacheMisses+" ("+Math.round(this._cacheMisses/a*100)+"%)"))}:_.noop,f});