define("io.ox/office/spreadsheet/utils/range",["io.ox/office/tk/utils","io.ox/office/tk/utils/iteratorutils","io.ox/office/spreadsheet/utils/interval","io.ox/office/spreadsheet/utils/address"],function(a,b,c,d){"use strict";function e(a,b){this.start=a,this.end=b?b:a.clone()}var f="("+d.COL_PATTERN+")("+d.ROW_PATTERN+")",g=new RegExp("^"+f+":"+f+"$","i");return e.create=function(a,b,c,f){var g=new d(Math.min(a,c),Math.min(b,f)),h=new d(Math.max(a,c),Math.max(b,f));return new e(g,h)},e.createFromIntervals=function(a,b){return e.create(a.first,b.first,a.last,b.last)},e.createFromColInterval=function(a,b,c){return"number"!=typeof c&&(c=b),e.create(a.first,b,a.last,c)},e.createFromRowInterval=function(a,b,c){return"number"!=typeof c&&(c=b),e.create(b,a.first,c,a.last)},e.createFromAddresses=function(a,b){return b?e.create(a[0],a[1],b[0],b[1]):new e(a.clone())},e.createFromAddressAndSize=function(a,b,c){return e.create(a[0],a[1],a[0]+b-1,a[1]+c-1)},e.parse=function(a,b){var c=g.exec(a);if(!c)return null;var f=d.parseCol(c[1],b?b[0]:null),h=d.parseRow(c[2],b?b[1]:null),i=d.parseCol(c[3],b?b[0]:null),j=d.parseRow(c[4],b?b[1]:null);return Math.min(f,h,i,j)>=0?e.create(f,h,i,j):null},e.compare=function(b,c){return a.comparePairs(b.start,b.end,c.start,c.end,d.compare)},e.prototype.key=function(){return this.start.key()+":"+this.end.key()},e.prototype.clone=function(){return new e(this.start.clone(),this.end.clone())},e.prototype.equals=function(a){return this.start.equals(a.start)&&this.end.equals(a.end)},e.prototype.differs=function(a){return this.start.differs(a.start)||this.end.differs(a.end)},e.prototype.compareTo=function(a){return e.compare(this,a)},e.prototype.cols=function(){return this.end[0]-this.start[0]+1},e.prototype.rows=function(){return this.end[1]-this.start[1]+1},e.prototype.size=function(a){return a?this.cols():this.rows()},e.prototype.cells=function(){return this.cols()*this.rows()},e.prototype.singleCol=function(){return this.start[0]===this.end[0]},e.prototype.singleRow=function(){return this.start[1]===this.end[1]},e.prototype.singleLine=function(a){return a?this.singleCol():this.singleRow()},e.prototype.single=function(){return this.start.equals(this.end)},e.prototype.startsAt=function(a){return this.start.equals(a)},e.prototype.endsAt=function(a){return this.end.equals(a)},e.prototype.indexAt=function(a){return(a[1]-this.start[1])*this.cols()+(a[0]-this.start[0])},e.prototype.addressAt=function(a){var b=this.cols();return new d(this.start[0]+Math.floor(a%b),this.start[1]+Math.floor(a/b))},e.prototype.containsCol=function(a){return this.start[0]<=a&&a<=this.end[0]},e.prototype.containsRow=function(a){return this.start[1]<=a&&a<=this.end[1]},e.prototype.containsIndex=function(a,b){return b?this.containsCol(a):this.containsRow(a)},e.prototype.containsAddress=function(a){return this.containsCol(a[0])&&this.containsRow(a[1])},e.prototype.isBorderAddress=function(a){return this.containsAddress(a)&&(this.start[0]===a[0]||this.end[0]===a[0]||this.start[1]===a[1]||this.end[1]===a[1])},e.prototype.contains=function(a){return this.containsAddress(a.start)&&this.containsAddress(a.end)},e.prototype.overlaps=function(a){return this.start[0]<=a.end[0]&&a.start[0]<=this.end[0]&&this.start[1]<=a.end[1]&&a.start[1]<=this.end[1]},e.prototype.colInterval=function(){return new c(this.start[0],this.end[0])},e.prototype.rowInterval=function(){return new c(this.start[1],this.end[1])},e.prototype.interval=function(a){return a?this.colInterval():this.rowInterval()},e.prototype.colRange=function(a,b){var c=this.start[0]+a;return e.create(c,this.start[1],c+(b||1)-1,this.end[1])},e.prototype.rowRange=function(a,b){var c=this.start[1]+a;return e.create(this.start[0],c,this.end[0],c+(b||1)-1)},e.prototype.lineRange=function(a,b,c){return a?this.colRange(b,c):this.rowRange(b,c)},e.prototype.leadingCol=function(){return e.create(this.start[0],this.start[1],this.start[0],this.end[1])},e.prototype.trailingCol=function(){return e.create(this.end[0],this.start[1],this.end[0],this.end[1])},e.prototype.headerRow=function(){return e.create(this.start[0],this.start[1],this.end[0],this.start[1])},e.prototype.footerRow=function(){return e.create(this.start[0],this.end[1],this.end[0],this.end[1])},e.prototype.mirror=function(){return new e(this.start.mirror(),this.end.mirror())},e.prototype.expand=function(a){return e.create(Math.min(this.start[0],a[0]),Math.min(this.start[1],a[1]),Math.max(this.end[0],a[0]),Math.max(this.end[1],a[1]))},e.prototype.boundary=function(a){return e.create(Math.min(this.start[0],a.start[0]),Math.min(this.start[1],a.start[1]),Math.max(this.end[0],a.end[0]),Math.max(this.end[1],a.end[1]))},e.prototype.intersect=function(a){return this.overlaps(a)?e.create(Math.max(this.start[0],a.start[0]),Math.max(this.start[1],a.start[1]),Math.min(this.end[0],a.end[0]),Math.min(this.end[1],a.end[1])):null},e.prototype.getStart=function(a){return this.start.get(a)},e.prototype.getEnd=function(a){return this.end.get(a)},e.prototype.setStart=function(a,b){return this.start.set(a,b),this},e.prototype.setEnd=function(a,b){return this.end.set(a,b),this},e.prototype.setBoth=function(a,b){return this.start.set(a,b),this.end.set(a,b),this},e.prototype.moveBoth=function(a,b){return this.start.move(a,b),this.end.move(a,b),this},e.prototype.iterator=function(c){var e=a.getBooleanOption(c,"columns",!1),f=this.interval(e).iterator(c),g=this.interval(!e),h=g.iterator.bind(g,c),i=e?function(a,b){return{value:new d(a.value,b.value)}}:function(a,b){return{value:new d(b.value,a.value)}};return b.createNestedIterator(f,h,i)},e.prototype.toString=function(){return this.start+":"+this.end},e.prototype.toJSON=function(){return{start:this.start.toJSON(),end:this.end.toJSON()}},_.makeExtendable(e)});